﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;

namespace ImagePinchZoom
{
    public partial class MainPage : PhoneApplicationPage
    {
        private double _initialAngle;
        private double _initialScale;

        // Constructor
        public MainPage()
        {
            InitializeComponent();
        }


        private void OnPinchStarted(object sender, PinchStartedGestureEventArgs e)
        {
            // store the initial rotation angle and scaling
            _initialAngle = ImageTransformation.Rotation;
            _initialScale = ImageTransformation.ScaleX;

            // calculate the center for the zooming
            Point firstTouch = e.GetPosition(MyImage, 0);
            Point secondTouch = e.GetPosition(MyImage, 1);

            Point center = new Point(firstTouch.X + (secondTouch.X - firstTouch.X) / 2.0,
                                        firstTouch.Y + (secondTouch.Y - firstTouch.Y) / 2.0);

            ImageTransformation.CenterX = center.X;
            ImageTransformation.CenterY = center.Y;

        }

        private void OnPinchDelta(object sender, PinchGestureEventArgs e)
        {
            // update the scaling
            ImageTransformation.ScaleX = _initialScale * e.DistanceRatio;
            ImageTransformation.ScaleY = ImageTransformation.ScaleX;
        }

        private void OnDragDelta(object sender, DragDeltaGestureEventArgs e)
        {
            ImageTransformation.TranslateX += e.HorizontalChange;
            ImageTransformation.TranslateY += e.VerticalChange;
        }
    }
}