﻿using System;
using Microsoft.Phone.Controls;
using System.Windows.Navigation;
using ODataSample.NorthwindServiceReference;
using System.Data.Services.Client;

namespace ODataSample
{
    public partial class DetailsPage : PhoneApplicationPage
    {
        NorthwindEntities context;
        private Customer thisCustomer;

        public DetailsPage()
        {
            InitializeComponent();
        }

        // When page is navigated to set data context to selected item in list
        protected override void OnNavigatedTo(NavigationEventArgs e)
        {
            string selectedIndex = "";
            int index;
            if (NavigationContext.QueryString.TryGetValue("selectedItem", out selectedIndex))
            {
                index = int.Parse(selectedIndex);
                thisCustomer = App.ViewModel.Customers[index].SelectedCustomer;
                DataContext = thisCustomer;
                context = new NorthwindEntities(new Uri("http://localhost:8321/NorthwindDataService.svc/"));
                context.AttachTo("Customers", thisCustomer);
            }

            
        }

        private void SaveChanges_Click(object sender, EventArgs e)
        {
            context.UpdateObject(thisCustomer);
            // Start the saving changes operation.
            context.BeginSaveChanges(SaveChangesOptions.Batch,
                OnChangesSaved, context);
            
        }

        private void OnChangesSaved(IAsyncResult result)
        {
            // Use the Dispatcher to ensure that the 
            // asynchronous call returns in the correct thread.
            Dispatcher.BeginInvoke(() =>
            {
                this.NavigationService.GoBack();   
            }
            );
        }
       
       
        
    }
}