﻿using System;
using System.Linq;
using System.ComponentModel;
using System.Globalization;
using System.Xml.Serialization;

namespace SerializationTester.ViewModels
{
    public enum ActivityPriority
    {
        Low,
        Normal,
        High
    }

    public enum ActivityStatus
    {
        Complete,
        Incomplete
    }

    public enum ActivityType
    {
        Meeting,
        Call
    }

    public class Activity : INotifyPropertyChanged
    {
        private ActivityType activityType;
        private DateTime due;
        private Lead lead;
        private ActivityPriority priority;
        private ActivityStatus status;
        private string subject;

        public DateTime Due
        {
            get { return due; }
            set
            {
                due = value;
                InvokePropertyChanged(new PropertyChangedEventArgs("Due"));
            }
        }

        //[XmlIgnore]
        //public Lead Lead
        //{
        //    get { return lead; }
        //    set
        //    {
        //        lead = value;
        //        InvokePropertyChanged(new PropertyChangedEventArgs("Lead"));
        //    }
        //}

        public ActivityPriority Priority
        {
            get { return priority; }
            set
            {
                priority = value;
                InvokePropertyChanged(new PropertyChangedEventArgs("Priority"));
            }
        }

        public ActivityStatus Status
        {
            get { return status; }
            set
            {
                status = value;
                InvokePropertyChanged(new PropertyChangedEventArgs("Status"));
            }
        }

        public string Subject
        {
            get { return subject ?? ""; }
            set
            {
                subject = value;
                InvokePropertyChanged(new PropertyChangedEventArgs("Subject"));
            }
        }

        public ActivityType ActivityType
        {
            get { return activityType; }
            set
            {
                activityType = value;
                InvokePropertyChanged(new PropertyChangedEventArgs("ActivityType"));
            }
        }

        #region INotifyPropertyChanged Members

        public event PropertyChangedEventHandler PropertyChanged;

        #endregion

        public void Deallocate()
        {
            //var leads = from l in  ((App)App.Current).Leads
            //                where(l.NextStep == this)
            //                select l;
            //foreach (var l in leads)
            //{
            //    l.NextStep = null;
            //}
            ((App)App.Current).Activities.Remove(this);
        }

        //public override string ToString()
        //{
        //    return string.Format(CultureInfo.CurrentCulture, "{0} {1}. {2}. {3}", Due, Subject,
        //                         Lead != null ? Lead.Name : "",
        //                         Lead != null && Lead.Contact != null ? Lead.Contact.LastName : "");
        //}

        private void InvokePropertyChanged(PropertyChangedEventArgs e)
        {
            var handler = PropertyChanged;
            if (handler != null) handler(this, e);
        }
    }
}
