using System.ComponentModel;
using System.Linq;
using System.Globalization;
using System.Collections.Generic;
using System.Xml.Serialization;

namespace SerializationTester.ViewModels
{
    public class Contact : INotifyPropertyChanged
    {
        private string address;
        private string company;
        private string email;
        private string firstName;
        private string lastName;

        public string Address
        {
            get { return address; }
            set
            {
                address = value;
                InvokePropertyChanged(new PropertyChangedEventArgs("Address"));
            }
        }

        public string Company
        {
            get { return company; }
            set
            {
                company = value;
                InvokePropertyChanged(new PropertyChangedEventArgs("Company"));
            }
        }

        public string Email
        {
            get { return email; }
            set
            {
                email = value;
                InvokePropertyChanged(new PropertyChangedEventArgs("Email"));
            }
        }

        public string FirstName
        {
            get { return firstName; }
            set
            {
                firstName = value;
                InvokePropertyChanged(new PropertyChangedEventArgs("FirstName"));
            }
        }

        //[XmlIgnore]
        //public Activity LastActivity
        //{
        //    get
        //    {
        //        return
        //            (from a in ((App)App.Current).Activities
        //                   .Where(activity => activity.Lead != null
        //                                   && activity.Lead.Contact == this)
        //                                   select a).FirstOrDefault();
        //    }
        //}

        public string LastName
        {
            get { return lastName; }
            set
            {
                if ((this.lastName != value))
                {
                     this.lastName = value;
                    InvokePropertyChanged(new PropertyChangedEventArgs("LastName"));
                }

            }
        }

        //[XmlIgnore]
        //public IList<Lead> Leads
        //{
        //    get {
        //        var query = from l in ((App)App.Current).Leads
        //                    where l.Contact == this
        //                    select l;
        //        return query.ToObservableCollection();
        //        //return Database.Select<Lead>(l => l.Contact == this).ToObservableCollection(); 
        //    }
        //}

        #region INotifyPropertyChanged Members

        public event PropertyChangedEventHandler PropertyChanged;

        #endregion

        public bool IsValid
        {
            get
            {
                if (this.lastName == null || this.lastName.Length == 0) return false;
                return true;
            }
        }

        public void Deallocate()
        {
            ((App)App.Current).Contacts.Remove(this);
        }

        public override string ToString()
        {
            return string.Format(CultureInfo.CurrentCulture, "{0} {1}", FirstName, LastName);
        }

        private void InvokePropertyChanged(PropertyChangedEventArgs e)
        {
            var handler = PropertyChanged;
            if (handler != null) handler(this, e);
        }
    }

}