﻿using System;
using System.ComponentModel;
using System.Collections.Generic;
using System.Linq;
using System.Xml.Serialization;

namespace SerializationTester.ViewModels
{
    public class Lead : INotifyPropertyChanged
    {
        private int amount;
        private Contact contact;
        private DateTime expectedClose;
        private string name;
        private Activity nextStep;
        private double probability;

        //[XmlIgnore]
        //public IEnumerable<Activity> Activities
        //{
        //    get {
        //        var query = from a in ((App)App.Current).Activities 
        //                    where a.Lead == this
        //                    select a;
        //        return query.ToObservableCollection();
        //    }
        //}

        public int Amount
        {
            get { return amount; }
            set
            {
                amount = value;
                InvokePropertyChanged(new PropertyChangedEventArgs("Amount"));
            }
        }

        //[XmlIgnore]
        //public Contact Contact
        //{
        //    get { return contact; }
        //    set
        //    {
        //        contact = value;
        //        InvokePropertyChanged(new PropertyChangedEventArgs("Contact"));
        //    }
        //}

        public DateTime ExpectedClose
        {
            get { return expectedClose; }
            set
            {
                expectedClose = value;
                InvokePropertyChanged(new PropertyChangedEventArgs("ExpectedClose"));
            }
        }

        public string Name
        {
            get { return name ?? ""; }
            set
            {
                name = value;
                InvokePropertyChanged(new PropertyChangedEventArgs("Name"));
            }
        }

        //[XmlIgnore]
        //public Activity NextStep
        //{
        //    get { return nextStep; }
        //    set
        //    {
        //        nextStep = value;
        //        InvokePropertyChanged(new PropertyChangedEventArgs("NextStep"));
        //    }
        //}

        public double Probability
        {
            get { return probability; }
            set
            {
                probability = value;
                InvokePropertyChanged(new PropertyChangedEventArgs("Probability"));
            }
        }

        #region INotifyPropertyChanged Members

        public event PropertyChangedEventHandler PropertyChanged;

        #endregion

        public void Deallocate()
        {
            //foreach (var activity in Activities)
            //{
            //    activity.Deallocate();
            //}
            ((App)App.Current).Leads.Remove(this);
        }

        //public override string ToString()
        //{
        //    return string.Format("{0}: {1}", Contact != null ? Contact.LastName : "", Name);
        //}

        private void InvokePropertyChanged(PropertyChangedEventArgs e)
        {
            var handler = PropertyChanged;
            if (handler != null) handler(this, e);
        }
    }

}
