﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;

namespace CRMapp
{
    public partial class LeadPivotPage : PhoneApplicationPage
    {
        public LeadPivotPage()
        {
            InitializeComponent();
        }

        protected override void OnNavigatedFrom(System.Windows.Navigation.NavigationEventArgs e)
        {
            base.OnNavigatedFrom(e);

            // Save OID of the current record we are viewing/editing
            State["DataContextObjectID"] = ((Lead)this.DataContext).LeadID;
        }
        
        protected override void OnNavigatedTo(System.Windows.Navigation.NavigationEventArgs e)
        {
            base.OnNavigatedTo(e);

            // For tombstoning, save the oid of a particular record in the State object on OnNavigatedFrom
            // Restore it in OnNavigatedTo and use the Database.Select<T> method to extract the correct one from the database
            if (State.ContainsKey("DataContextObjectID"))
            {
                long leadid = (long)State["DataContextObjectID"];
                this.DataContext =
                    (from l in db.Leads
                     where l.LeadID == leadid
                     select l).FirstOrDefault();
                State.Remove("DataContextObjectID");
            }


            // Have we come here by navigating from the MainPage after selecting a record in the main list?
            if (this.NavigationContext.QueryString.ContainsKey("oid"))
            {
                long leadid = Int64.Parse(NavigationContext.QueryString["oid"]);
                this.DataContext =
                    (from l in db.Leads
                     where l.LeadID == leadid
                     select l).FirstOrDefault();
            }
        }

        private CRMDataContext db
        {
            get
            {
                return ((App)App.Current).CRMDataContext;
            }
        }
    }
}