﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;

using System.Xml.Linq;

namespace TwitterReader
{
    public partial class MainPage : PhoneApplicationPage
    {
        WebClient client;

        // Constructor
        public MainPage()
        {
            InitializeComponent();

            TwitterPost p1 = new TwitterPost
            {
                DatePosted = "Tue Oct 12 11:57:37 +0000 2010",
                UserImage = "http://a3.twimg.com/profile_images/150108107/me2_normal.jpg",
                PostText = "This is a test post from Rob"
            };

            TwitterPost p2 = new TwitterPost
            {
                DatePosted = "Wed Oct 13 14:21:04 +0000 2010",
                UserImage = "http://a3.twimg.com/profile_images/150108107/me2_normal.jpg",
                PostText = "This is another test post from Rob"
            };

            List<TwitterPost> posts = new List<TwitterPost>();
            posts.Add(p1);
            posts.Add(p2);

            tweetsListBox.ItemsSource = posts;

            client = new WebClient();
            client.DownloadStringCompleted +=
                         new DownloadStringCompletedEventHandler(
                             client_DownloadStringCompleted);
        }

        void client_DownloadStringCompleted(object sender,
                                    DownloadStringCompletedEventArgs e)
        {
            if (e.Error == null)
            {
            XElement twitterElements = XElement.Parse(e.Result);

            var postList = 
                from tweet in twitterElements.Descendants("status")
                select new TwitterPost
                {
                    UserImage = tweet.Element("user").Element("profile_image_url").Value,
                    PostText = tweet.Element("text").Value,
                    DatePosted = tweet.Element("created_at").Value
                };

                tweetsListBox.ItemsSource = postList;
            }
        }

        private void loadButton_Click(object sender, RoutedEventArgs e)
        {
            string url = "http://twitter.com/statuses/user_timeline/" +
                         nameTextBox.Text + ".xml";
            client.DownloadStringAsync(new Uri(url));
        }
    }
}