﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;
using System.Xml.Linq;
using WindowsPhoneApplication1.Model;

namespace WindowsPhoneApplication1
{
    public partial class MainPage : PhoneApplicationPage
    {
        // Constructor
        public MainPage()
        {
            InitializeComponent();
        }

        private void PhoneApplicationPage_Loaded(object sender, RoutedEventArgs e)
        {
            var request = HttpWebRequest.Create("http://localhost:1481/NorthwindDataService/NorthwindDataService.svc/Suppliers") as HttpWebRequest;
            request.Accept = "application/json";
            var resp = request.BeginGetResponse(new AsyncCallback(GotJSON), request);
        }

        private void GotJSON(IAsyncResult asynchronousResult)
        {
            // State of request is asynchronous.
            HttpWebRequest myHttpWebRequest = (HttpWebRequest)asynchronousResult.AsyncState; ;
            HttpWebResponse response = (HttpWebResponse)myHttpWebRequest.EndGetResponse(asynchronousResult);

            // Read the response into a Stream object.
            System.IO.Stream responseStream = response.GetResponseStream();

            string data;
            using (var reader = new System.IO.StreamReader(responseStream))
            {
                data = reader.ReadToEnd();
            }

            this.Dispatcher.BeginInvoke(() =>
                {
                    var feed = Newtonsoft.Json.JsonConvert.DeserializeObject<SupplierODataFeed>(data);
                    MessageBox.Show("Received payload of " + data.Length + " characters");

                    SuppliersList.ItemsSource = feed.d;
                }
            );

        }
    }
}