﻿using System;
using System.ComponentModel;
using ODataSample.NorthwindServiceReference;

namespace ODataSample
{
    public class CustomerViewModel : INotifyPropertyChanged
    {
        private Customer selectedCustomer;
        public Customer SelectedCustomer
        {
            get
            {
                return selectedCustomer;
            }
            set
            {
                if (value != selectedCustomer)
                {
                    selectedCustomer = value;
                    NotifyPropertyChanged("SelectedCustomer");
                }
            }
        }
       
        public event PropertyChangedEventHandler PropertyChanged;
        private void NotifyPropertyChanged(String propertyName)
        {
            PropertyChangedEventHandler handler = PropertyChanged;
            if (null != handler)
            {
                handler(this, new PropertyChangedEventArgs(propertyName));
            }
        }
    }
}
