﻿using System;
using Microsoft.Phone.Controls;
using System.Windows.Navigation;
using ODataSample.NorthwindServiceReference;
using System.Data.Services.Client;
using System.Windows.Input;
using System.Windows.Controls;

namespace ODataSample
{
    public partial class DetailsPage : PhoneApplicationPage
    {
        NorthwindEntities context;

        public DetailsPage()
        {
            InitializeComponent();
        }

        // When page is navigated to set data context to selected item in list
        protected override void OnNavigatedTo(NavigationEventArgs e)
        {
            string selectedIndex = "";
            int index;
            if (NavigationContext.QueryString.TryGetValue("selectedItem", out selectedIndex))
            {
                index = int.Parse(selectedIndex);
                DataContext = App.ViewModel.Customers[index].SelectedCustomer;
                context = new NorthwindEntities(new Uri("http://localhost:8321/NorthwindDataService.svc/"));
                context.AttachTo("Customers", (Customer)DataContext);
            }

            
        }

        private void SaveChanges_Click(object sender, EventArgs e)
        {
            object focusObj = FocusManager.GetFocusedElement();
            if (focusObj != null && focusObj is TextBox)
            {
                var binding = (focusObj as TextBox).GetBindingExpression(TextBox.TextProperty);
                binding.UpdateSource();
            }

            context.UpdateObject((Customer)DataContext);
            // Start the saving changes operation.
            context.BeginSaveChanges(SaveChangesOptions.Batch,
                OnChangesSaved, context);
            
        }

        private void OnChangesSaved(IAsyncResult result)
        {
            // Use the Dispatcher to ensure that the 
            // asynchronous call returns in the correct thread.
            Dispatcher.BeginInvoke(() =>
            {
                context = result.AsyncState as NorthwindEntities;

                this.NavigationService.GoBack();
                
            }
            );
        }
       
       
        
    }
}