﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;
using System.Xml.Linq;

namespace WindowsPhoneApplication1
{
    public partial class MainPage : PhoneApplicationPage
    {
        DataSetServiceReference.ServiceSoapClient client = new DataSetServiceReference.ServiceSoapClient();
        WebClient webclient = new WebClient();

        // Constructor
        public MainPage()
        {
            InitializeComponent();
            client.GetSuppliersCompleted += new EventHandler<DataSetServiceReference.GetSuppliersCompletedEventArgs>(client_GetSuppliersCompleted);
            webclient.DownloadStringCompleted += new DownloadStringCompletedEventHandler(webclient_DownloadStringCompleted);
        }

        private void button1_Click(object sender, RoutedEventArgs e)
        {
            client.GetSuppliersAsync();
        }

        private void button2_Click(object sender, RoutedEventArgs e)
        {
            webclient.DownloadStringAsync(new Uri("http://localhost:1481/NorthwindDataService/NorthwindDataService.svc/Suppliers"));
        }

        void client_GetSuppliersCompleted(object sender, DataSetServiceReference.GetSuppliersCompletedEventArgs e)
        {
            MessageBox.Show("Received payload of " + e.Result.ToString().Length + " characters");
            
        }

        void webclient_DownloadStringCompleted(object sender, DownloadStringCompletedEventArgs e)
        {
            MessageBox.Show("Received payload of " + e.Result.ToString().Length + " characters");
        }

        private void button3_Click(object sender, RoutedEventArgs e)
        {
            var request = HttpWebRequest.Create("http://localhost:1481/NorthwindDataService/NorthwindDataService.svc/Suppliers") as HttpWebRequest;
                request.Accept = "application/json";
                var resp = request.BeginGetResponse(new AsyncCallback(GotJSON), request);
        }

        private void GotJSON(IAsyncResult asynchronousResult)
        {
            // State of request is asynchronous.
            HttpWebRequest myHttpWebRequest = (HttpWebRequest)asynchronousResult.AsyncState; ;
            HttpWebResponse response = (HttpWebResponse)myHttpWebRequest.EndGetResponse(asynchronousResult);

            // Read the response into a Stream object.
            System.IO.Stream responseStream = response.GetResponseStream();

            string data;
            using (var reader = new System.IO.StreamReader(responseStream))
            {
                data = reader.ReadToEnd();
            }

            this.Dispatcher.BeginInvoke(() =>
                MessageBox.Show("Received payload of " + data.Length + " characters")
            );

        }

        private void button4_Click(object sender, RoutedEventArgs e)
        {
            webclient.DownloadStringAsync(new Uri("http://localhost:1481/NorthwindDataService/NorthwindDataService.svc/GetSuppliersLite"));
        }

        private void button5_Click(object sender, RoutedEventArgs e)
        {
            webclient.DownloadStringAsync(new Uri("http://localhost:1481/NorthwindDataService/NorthwindDataService.svc/GetSuppliersLiteZip"));
        }

    }
}