﻿// ----------------------------------------------------------------------------------
// Microsoft Developer & Platform Evangelism
// 
// Copyright (c) Microsoft Corporation. All rights reserved.
// 
// THIS CODE AND INFORMATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, 
// EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES 
// OF MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR PURPOSE.
// ----------------------------------------------------------------------------------
// The example companies, organizations, products, domain names,
// e-mail addresses, logos, people, places, and events depicted
// herein are fictitious.  No association with any real company,
// organization, product, domain name, email address, logo, person,
// places, or events is intended or should be inferred.
// ----------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace TaskLocationAgent
{
    public enum TaskHelperCompletionStatus 
    { 
        Started, 
        Completed, 
        Failed, 
        TimedOut, 
        Blocked 
    }; 

    public class TaskHelperEventArgs  : EventArgs 
    {
        public TaskHelperEventArgs(TaskHelperCompletionStatus status)
            : base()
        {
            Status = status;  
        }
        public TaskHelperCompletionStatus Status
        {
            get;
            private set;
        } 
    } 
    interface IBackgroundTaskHelper
    {
        event EventHandler<TaskHelperEventArgs> Completed;
        void Start();
        void Stop();
        int ProgressCompleted { get; }
        TaskHelperCompletionStatus Status { get; } 
    }
}
