﻿// ----------------------------------------------------------------------------------
// Microsoft Developer & Platform Evangelism
// 
// Copyright (c) Microsoft Corporation. All rights reserved.
// 
// THIS CODE AND INFORMATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, 
// EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES 
// OF MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR PURPOSE.
// ----------------------------------------------------------------------------------
// The example companies, organizations, products, domain names,
// e-mail addresses, logos, people, places, and events depicted
// herein are fictitious.  No association with any real company,
// organization, product, domain name, email address, logo, person,
// places, or events is intended or should be inferred.
// ----------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel;

namespace Todo.Interfaces
{
    /// <summary>
    /// Defines an object capable of firing notifications when its properties are changed.
    /// </summary>
    public interface IPropertyChangedNotifier : INotifyPropertyChanged
    {
        /// <summary>
        /// Fires an event which indicates that a property has changed.
        /// </summary>
        /// <param name="propertyName">The name of the property that has changed.</param>
        void SendPropertyChanged(String propertyName);
    }
}
