﻿// ----------------------------------------------------------------------------------
// Microsoft Developer & Platform Evangelism
// 
// Copyright (c) Microsoft Corporation. All rights reserved.
// 
// THIS CODE AND INFORMATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, 
// EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES 
// OF MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR PURPOSE.
// ----------------------------------------------------------------------------------
// The example companies, organizations, products, domain names,
// e-mail addresses, logos, people, places, and events depicted
// herein are fictitious.  No association with any real company,
// organization, product, domain name, email address, logo, person,
// places, or events is intended or should be inferred.
// ----------------------------------------------------------------------------------

using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Collections.Generic;

namespace Todo.Misc
{
    /// <summary>
    /// A list of color entries.
    /// </summary>
    public class ColorEntryList : List<ColorEntry> { }

    /// <summary>
    /// Associates a color with a name to present it as a choice to the user.
    /// </summary>
    public class ColorEntry
    {
        /// <summary>
        /// The entry's color (#AARRGGBB).
        /// </summary>
        public string Color { get; set; }

        /// <summary>
        /// The name of the entry's color.
        /// </summary>
        public string Name { get; set; }
    }
}
