﻿// ----------------------------------------------------------------------------------
// Microsoft Developer & Platform Evangelism
// 
// Copyright (c) Microsoft Corporation. All rights reserved.
// 
// THIS CODE AND INFORMATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, 
// EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES 
// OF MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR PURPOSE.
// ----------------------------------------------------------------------------------
// The example companies, organizations, products, domain names,
// e-mail addresses, logos, people, places, and events depicted
// herein are fictitious.  No association with any real company,
// organization, product, domain name, email address, logo, person,
// places, or events is intended or should be inferred.
// ----------------------------------------------------------------------------------

using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Collections.Generic;

namespace Todo.Misc
{
    public class NamedProjectGroup : NamedGroup<Task>
    {
        /// <summary>
        /// Gets or sets the project associated with the contained items.
        /// </summary>
        public Project Project { get; set; }

        /// <summary>
        /// Creates a new group of items.
        /// </summary>
        /// <param name="title">The group's title.</param>
        /// <param name="items">The items to include in the group.</param>
        /// <param name="project">The project to which the items contained in the group belong.</param>
        public NamedProjectGroup(string title, IEnumerable<Task> items, Project project) : 
            base(title, items)
        {
            Project = project;
        }
    }
}
