﻿// ----------------------------------------------------------------------------------
// Microsoft Developer & Platform Evangelism
// 
// Copyright (c) Microsoft Corporation. All rights reserved.
// 
// THIS CODE AND INFORMATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, 
// EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES 
// OF MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR PURPOSE.
// ----------------------------------------------------------------------------------
// The example companies, organizations, products, domain names,
// e-mail addresses, logos, people, places, and events depicted
// herein are fictitious.  No association with any real company,
// organization, product, domain name, email address, logo, person,
// places, or events is intended or should be inferred.
// ----------------------------------------------------------------------------------

using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.IO.IsolatedStorage;
using System.Runtime.Serialization;

namespace Todo.Misc
{
    public class SettingsWorkaround
    {
        public bool UseLocation { get; set; }
        public bool UseTileUpdater { get; set; }
        public bool HideOnRefresh { get; set; }
        public bool HideOnStartup { get; set; }
        public bool BackupNightly { get; set; }

        public void Save()
        {
            Save(SettingsPath);
        }
        public void Save(string filename)
        {
            try
            {
                using (var file = IsolatedStorageFile.GetUserStoreForApplication())
                {
                    using (var stream = file.OpenFile(filename, System.IO.FileMode.Create))
                    {
                        DataContractSerializer ser = new DataContractSerializer(typeof(SettingsWorkaround));
                        ser.WriteObject(stream, this);
                    }
                }
            }
            catch (Exception )
            {
                //TODO: 
            }
        }


        public static SettingsWorkaround Load()
        {
            return Load(SettingsPath);
        }

        public static SettingsWorkaround Load(string filename)
        {
            SettingsWorkaround settings = null;
            try
            {
                using (var file = IsolatedStorageFile.GetUserStoreForApplication())
                {
                    if (file.FileExists(filename))
                    {
                        using (var stream = file.OpenFile(filename, System.IO.FileMode.Open))
                        {
                            DataContractSerializer ser = new DataContractSerializer(typeof(SettingsWorkaround));
                            settings = ser.ReadObject(stream) as SettingsWorkaround;
                        }
                    }
                }
            }
            catch (Exception )
            {
                //TODO: 
            }
            return settings;
        }

        public const string SettingsPath = "settingsworkaround.xml";

    } 
}
