﻿// ----------------------------------------------------------------------------------
// Microsoft Developer & Platform Evangelism
// 
// Copyright (c) Microsoft Corporation. All rights reserved.
// 
// THIS CODE AND INFORMATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, 
// EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES 
// OF MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR PURPOSE.
// ----------------------------------------------------------------------------------
// The example companies, organizations, products, domain names,
// e-mail addresses, logos, people, places, and events depicted
// herein are fictitious.  No association with any real company,
// organization, product, domain name, email address, logo, person,
// places, or events is intended or should be inferred.
// ----------------------------------------------------------------------------------

using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Shell;
using System.Linq;

namespace Todo.Shell
{
    public static class ShellTileHelpersCore
    {
        public static bool IsPinned(Uri uri)
        {
            var item = ShellTile.ActiveTiles.FirstOrDefault
                (x => x.NavigationUri == uri);

            return item != null;
        }

        public static bool IsPinned(string uniqueId)
        {
            var item = ShellTile.ActiveTiles.FirstOrDefault
                (x => x.NavigationUri.ToString().Contains(uniqueId));

            return item != null;
        }


        public static void Pin(Uri uri, ShellTileData initialData)
        {
            // Create the tile and pin to start. This will cause the app to be deactivated
            ShellTile.Create(uri, initialData);

        }

        public static void UnPin(string id)
        {
            var item = ShellTile.ActiveTiles.FirstOrDefault
                        (x => x.NavigationUri.ToString().Contains(id));

            if (item != null)
                item.Delete();
        }
        public static void UnPin(Uri uri)
        {
            var item = ShellTile.ActiveTiles.FirstOrDefault
                (x => x.NavigationUri == uri);

            if (item != null)
                item.Delete();
        }
    }
}
