﻿// ----------------------------------------------------------------------------------
// Microsoft Developer & Platform Evangelism
// 
// Copyright (c) Microsoft Corporation. All rights reserved.
// 
// THIS CODE AND INFORMATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, 
// EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES 
// OF MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR PURPOSE.
// ----------------------------------------------------------------------------------
// The example companies, organizations, products, domain names,
// e-mail addresses, logos, people, places, and events depicted
// herein are fictitious.  No association with any real company,
// organization, product, domain name, email address, logo, person,
// places, or events is intended or should be inferred.
// ----------------------------------------------------------------------------------

using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Windows.Data;
using Todo.Misc;

namespace Todo.Converters
{
    /// <summary>
    /// Converts an attachment type GUID into an image which represents the attachment type.
    /// </summary>
    public class AttachmentTypeIDToImageURIConverter : IValueConverter
    {
        #region IValueConverter Members

        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            Uri theUri = null;
            switch (value.ToString())
            {
                case Utils.AttachmentTypeIDText: //Text
                    theUri = new Uri("/Images/text.png", UriKind.Relative);
                    break;
                case Utils.AttachmentTypeIDImage: //Image
                    theUri = new Uri("/Images/image.png", UriKind.Relative);
                    break;
                case Utils.AttachmentTypeIDVoice: //Voice
                    theUri = new Uri("/Images/voice.png", UriKind.Relative);
                    break;
                default: //Text
                    theUri = new Uri("/Images/text.png", UriKind.Relative);
                    break; 
            }

            return theUri;
        }

        public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            throw new NotImplementedException();
        }

        #endregion
    }
}
