﻿// ----------------------------------------------------------------------------------
// Microsoft Developer & Platform Evangelism
// 
// Copyright (c) Microsoft Corporation. All rights reserved.
// 
// THIS CODE AND INFORMATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, 
// EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES 
// OF MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR PURPOSE.
// ----------------------------------------------------------------------------------
// The example companies, organizations, products, domain names,
// e-mail addresses, logos, people, places, and events depicted
// herein are fictitious.  No association with any real company,
// organization, product, domain name, email address, logo, person,
// places, or events is intended or should be inferred.
// ----------------------------------------------------------------------------------

using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Collections.Generic;
using System.Device.Location;

namespace Todo 
{
    public static class LocationHelper
    {
        public static bool IsNearBy(this Location location, GeoCoordinate pointCoordinate, double distanceThreshold = 1.0)
        {
            double distance = GeoCodeDistanceCalc.CalcDistance(location.Latitude, location.Longitude,
                              pointCoordinate.Latitude, pointCoordinate.Longitude);
            return (distance <= distanceThreshold);  
        }

        public static Location FindNearestMeetingThreshold(IEnumerable<Location> locations,
                    GeoCoordinate pointCoordinate, double threshold = 1.0)
        {
            double distance = 2000000;
            Location foundLocation = null; 
            foreach (Location location in locations)
            {
                double newdistance = GeoCodeDistanceCalc.CalcDistance(location.Latitude, location.Longitude,
                                                     pointCoordinate.Latitude, pointCoordinate.Longitude);

                if (newdistance < threshold && newdistance < distance)
                {
                    foundLocation = location;
                    distance = newdistance; 
                } 
            }
            return foundLocation; 

        } 
        
    }
}
