﻿// ----------------------------------------------------------------------------------
// Microsoft Developer & Platform Evangelism
// 
// Copyright (c) Microsoft Corporation. All rights reserved.
// 
// THIS CODE AND INFORMATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, 
// EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES 
// OF MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR PURPOSE.
// ----------------------------------------------------------------------------------
// The example companies, organizations, products, domain names,
// e-mail addresses, logos, people, places, and events depicted
// herein are fictitious.  No association with any real company,
// organization, product, domain name, email address, logo, person,
// places, or events is intended or should be inferred.
// ----------------------------------------------------------------------------------

using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Windows.Threading;
using Microsoft.Xna.Framework;

namespace Todo
{
    public class XNAAsyncDispatcher : IApplicationService
    {
        private DispatcherTimer frameworkDispatcherTimer; 
        public XNAAsyncDispatcher(TimeSpan dispatchInterval) 
        { 
            this.frameworkDispatcherTimer = new DispatcherTimer(); 
            this.frameworkDispatcherTimer.Tick += new EventHandler(frameworkDispatcherTimer_Tick); 
            this.frameworkDispatcherTimer.Interval = dispatchInterval; 
        }     
        
        void IApplicationService.StartService(ApplicationServiceContext context) 
        { 
            this.frameworkDispatcherTimer.Start(); 
        }     
        
        void IApplicationService.StopService() 
        { 
            this.frameworkDispatcherTimer.Stop(); 
        }     
        
        void frameworkDispatcherTimer_Tick(object sender, EventArgs e) 
        { 
            FrameworkDispatcher.Update(); 
        }
    }
}
