﻿// ----------------------------------------------------------------------------------
// Microsoft Developer & Platform Evangelism
// 
// Copyright (c) Microsoft Corporation. All rights reserved.
// 
// THIS CODE AND INFORMATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, 
// EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES 
// OF MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR PURPOSE.
// ----------------------------------------------------------------------------------
// The example companies, organizations, products, domain names,
// e-mail addresses, logos, people, places, and events depicted
// herein are fictitious.  No association with any real company,
// organization, product, domain name, email address, logo, person,
// places, or events is intended or should be inferred.
// ----------------------------------------------------------------------------------

#pragma warning disable 1591
//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated by a tool.
//     Runtime Version:2.0.50727.5420
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Data.Linq;
using System.Data.Linq.Mapping;
using System.Linq;
using System.Linq.Expressions;
using System.Reflection;
using Todo.Misc;
using Todo.Interfaces;
using Microsoft.Phone.Data.Linq.Mapping;


namespace Todo
{
    public partial class DataContextBase : System.Data.Linq.DataContext
    {

        private static System.Data.Linq.Mapping.MappingSource mappingSource = new AttributeMappingSource();

        #region Extensibility Method Definitions
        partial void OnCreated();
        partial void InsertAttachment(Attachment instance);
        partial void UpdateAttachment(Attachment instance);
        partial void DeleteAttachment(Attachment instance);
        partial void InsertAttachmentType(AttachmentType instance);
        partial void UpdateAttachmentType(AttachmentType instance);
        partial void DeleteAttachmentType(AttachmentType instance);
        partial void InsertItems(Task instance);
        partial void UpdateItems(Task instance);
        partial void DeleteItems(Task instance);
        partial void InsertProjects(Project instance);
        partial void UpdateProjects(Project instance);
        partial void DeleteProjects(Project instance);
        #endregion

        public DataContextBase(string connection) :
            base(connection, mappingSource)
        {
            OnCreated();
        }

        public DataContextBase(string connection, System.Data.Linq.Mapping.MappingSource mappingSource) :
            base(connection, mappingSource)
        {
            OnCreated();
        }

        public System.Data.Linq.Table<Attachment> Attachment
        {
            get
            {
                return this.GetTable<Attachment>();
            }
        }

        public System.Data.Linq.Table<AttachmentType> AttachmentType
        {
            get
            {
                return this.GetTable<AttachmentType>();
            }
        }

        public System.Data.Linq.Table<Task> Items
        {
            get
            {
                return this.GetTable<Task>();
            }
        }

        public System.Data.Linq.Table<Project> Projects
        {
            get
            {
                return this.GetTable<Project>();
            }
        }

        public System.Data.Linq.Table<Location> Locations
        {
            get
            {
                return this.GetTable<Location>();
            }
        }
    }


    [Table( Name="Attachments" )]
    public partial class Attachment : INotifyPropertyChanging, IPropertyChangedNotifier, ITodoTable
    {

        private static PropertyChangingEventArgs emptyChangingEventArgs = new PropertyChangingEventArgs(String.Empty);

        private System.Guid _AttachmentID;

        private System.Guid _AttachmentTypeID;

        private string _TextNote;

        private double _Length;

        private System.Data.Linq.Binary _Blob;

        private System.Guid _ItemID;

        private EntityRef<AttachmentType> _AttachmentType;

        private EntityRef<Task> _Items;

        #region Extensibility Method Definitions
        partial void OnLoaded();
        partial void OnValidate(System.Data.Linq.ChangeAction action);
        partial void OnCreated();
        partial void OnLengthChanging(double value);
        partial void OnLengthChanged();
        partial void OnAttachmentIDChanging(System.Guid value);
        partial void OnAttachmentIDChanged();
        partial void OnAttachmentTypeIDChanging(System.Guid value);
        partial void OnAttachmentTypeIDChanged();
        partial void OnTextNoteChanging(string value);
        partial void OnTextNoteChanged();
        partial void OnBlobChanging(System.Data.Linq.Binary value);
        partial void OnBlobChanged();
        partial void OnItemIDChanging(System.Guid value);
        partial void OnItemIDChanged();
        #endregion

        public Attachment()
        {
            this._AttachmentType = default(EntityRef<AttachmentType>);
            this._Items = default(EntityRef<Task>);
            this._AttachmentTypeID = new Guid(Utils.AttachmentTypeIDText);
            OnCreated();
        }

        [Column(Storage = "_Length", DbType = "Float NOT NULL")]
        public double Length
        {
            get
            {
                return this._Length;
            }
            set
            {
                if ((this._Length != value))
                {
                    this.OnLengthChanging(value);
                    this.SendPropertyChanging();
                    this._Length = value;
                    this.SendPropertyChanged("Length");
                    this.OnLengthChanged();
                }
            }
        }

        [Column(Storage = "_AttachmentID", DbType = "UniqueIdentifier NOT NULL", IsPrimaryKey = true)]
        public System.Guid Id
        {
            get
            {
                return this._AttachmentID;
            }
            set
            {
                if ((this._AttachmentID != value))
                {
                    this.OnAttachmentIDChanging(value);
                    this.SendPropertyChanging();
                    this._AttachmentID = value;
                    this.SendPropertyChanged("Id");
                    this.OnAttachmentIDChanged();
                }
            }
        }

        [Column(Storage = "_AttachmentTypeID", DbType = "UniqueIdentifier NOT NULL")]
        public System.Guid AttachmentTypeID
        {
            get
            {
                return this._AttachmentTypeID;
            }
            set
            {
                if ((this._AttachmentTypeID != value))
                {
                    if (this._AttachmentType.HasLoadedOrAssignedValue)
                    {
                        throw new System.Data.Linq.ForeignKeyReferenceAlreadyHasValueException();
                    }
                    this.OnAttachmentTypeIDChanging(value);
                    this.SendPropertyChanging();
                    this._AttachmentTypeID = value;
                    this.SendPropertyChanged("AttachmentTypeID");
                    this.OnAttachmentTypeIDChanged();
                }
            }
        }

        [Column(Storage = "_TextNote", DbType = "NVarChar(255)")]
        public string TextNote
        {
            get
            {
                return this._TextNote;
            }
            set
            {
                if ((this._TextNote != value))
                {
                    this.OnTextNoteChanging(value);
                    this.SendPropertyChanging();
                    this._TextNote = value;
                    this.SendPropertyChanged("TextNote");
                    this.OnTextNoteChanged();
                }
            }
        }

        [Column(Storage = "_Blob", DbType = "Image", CanBeNull = true, UpdateCheck = UpdateCheck.Never)]
        public System.Data.Linq.Binary Blob
        {
            get
            {
                return this._Blob;
            }
            set
            {
                if ((this._Blob != value))
                {
                    this.OnBlobChanging(value);
                    this.SendPropertyChanging();
                    this._Blob = value;
                    this.SendPropertyChanged("Blob");
                    this.OnBlobChanged();
                }
            }
        }

        [Column(Storage = "_ItemID", DbType = "UniqueIdentifier NOT NULL")]
        public System.Guid ItemID
        {
            get
            {
                return this._ItemID;
            }
            set
            {
                if ((this._ItemID != value))
                {
                    if (this._Items.HasLoadedOrAssignedValue)
                    {
                        throw new System.Data.Linq.ForeignKeyReferenceAlreadyHasValueException();
                    }
                    this.OnItemIDChanging(value);
                    this.SendPropertyChanging();
                    this._ItemID = value;
                    this.SendPropertyChanged("ItemID");
                    this.OnItemIDChanged();
                }
            }
        }

        [Association(Name = "Attachment_AttachmentType", Storage = "_AttachmentType", ThisKey = "AttachmentTypeID", OtherKey="Id", IsForeignKey = true)]
        public AttachmentType AttachmentType
        {
            get
            {
                return this._AttachmentType.Entity;
            }
            set
            {
                AttachmentType previousValue = this._AttachmentType.Entity;
                if (((previousValue != value)
                            || (this._AttachmentType.HasLoadedOrAssignedValue == false)))
                {
                    this.SendPropertyChanging();
                    if ((previousValue != null))
                    {
                        this._AttachmentType.Entity = null;
                    }
                    this._AttachmentType.Entity = value;
                    if ((value != null))
                    {
                        this._AttachmentTypeID = value.Id;
                    }
                    else
                    {
                        this._AttachmentTypeID = default(System.Guid);
                    }
                    this.SendPropertyChanged("AttachmentType");
                }
            }
        }

        [Association(Name = "Attachment_Items", Storage = "_Items", ThisKey = "ItemID", OtherKey = "Id", IsForeignKey = true)]
        public Task Items
        {
            get
            {
                return this._Items.Entity;
            }
            set
            {
                Task previousValue = this._Items.Entity;
                if (((previousValue != value)
                            || (this._Items.HasLoadedOrAssignedValue == false)))
                {
                    this.SendPropertyChanging();
                    if ((previousValue != null))
                    {
                        this._Items.Entity = null;
                        previousValue.Attachment.Remove(this);
                    }
                    this._Items.Entity = value;
                    if ((value != null))
                    {
                        value.Attachment.Add(this);
                        this._ItemID = value.Id;
                    }
                    else
                    {
                        this._ItemID = default(System.Guid);
                    }
                    this.SendPropertyChanged("Items");
                }
            }
        }

        public event PropertyChangingEventHandler PropertyChanging;

        public event PropertyChangedEventHandler PropertyChanged;

        protected virtual void SendPropertyChanging()
        {
            if ((this.PropertyChanging != null))
            {
                this.PropertyChanging(this, emptyChangingEventArgs);
            }
        }

        public virtual void SendPropertyChanged(String propertyName)
        {
            if ((this.PropertyChanged != null))
            {
                this.PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }
    }

    [Table( Name="AttachmentTypes")]
    public partial class AttachmentType : INotifyPropertyChanging, IPropertyChangedNotifier, ITodoTable
    {

        private static PropertyChangingEventArgs emptyChangingEventArgs = new PropertyChangingEventArgs(String.Empty);

        private System.Guid _AttachmentTypeID;

        private string _Name;

        #region Extensibility Method Definitions
        partial void OnLoaded();
        partial void OnValidate(System.Data.Linq.ChangeAction action);
        partial void OnCreated();
        partial void OnAttachmentTypeIDChanging(System.Guid value);
        partial void OnAttachmentTypeIDChanged();
        partial void OnNameChanging(string value);
        partial void OnNameChanged();
        #endregion

        public AttachmentType()
        {
            OnCreated();
        }

        [Column(Storage = "_AttachmentTypeID", DbType = "UniqueIdentifier NOT NULL", IsPrimaryKey = true)]
        public System.Guid Id
        {
            get
            {
                return this._AttachmentTypeID;
            }
            set
            {
                if ((this._AttachmentTypeID != value))
                {
                    this.OnAttachmentTypeIDChanging(value);
                    this.SendPropertyChanging();
                    this._AttachmentTypeID = value;
                    this.SendPropertyChanged("Id");
                    this.OnAttachmentTypeIDChanged();
                }
            }
        }

        [Column(Storage = "_Name", DbType = "NVarChar(50) NOT NULL", CanBeNull = false)]
        public string Name
        {
            get
            {
                return this._Name;
            }
            set
            {
                if ((this._Name != value))
                {
                    this.OnNameChanging(value);
                    this.SendPropertyChanging();
                    this._Name = value;
                    this.SendPropertyChanged("Name");
                    this.OnNameChanged();
                }
            }
        }

        public event PropertyChangingEventHandler PropertyChanging;

        public event PropertyChangedEventHandler PropertyChanged;

        protected virtual void SendPropertyChanging()
        {
            if ((this.PropertyChanging != null))
            {
                this.PropertyChanging(this, emptyChangingEventArgs);
            }
        }

        public virtual void SendPropertyChanged(String propertyName)
        {
            if ((this.PropertyChanged != null))
            {
                this.PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }
    }

    [Table( Name="Tasks")]
    public partial class Task : INotifyPropertyChanging, IPropertyChangedNotifier, ITodoTable
    {

        private static PropertyChangingEventArgs emptyChangingEventArgs = new PropertyChangingEventArgs(String.Empty);

        private System.Guid _ItemID;
        private System.Guid _ProjectID;
        private System.Guid _LocationID; 

        private bool _Completed;
        private string _Title;

        private System.Nullable<System.DateTime> _DueDate;
        
        private TaskStatus _Status; 
        private EntitySet<Attachment> _Attachment;
        private PriorityValue _Priority;

        private EntityRef<Project> _Projects;
        private EntityRef<Location> _Location; 

        #region Extensibility Method Definitions
        partial void OnLoaded();
        partial void OnValidate(System.Data.Linq.ChangeAction action);
        partial void OnCreated();
        partial void OnItemIDChanging(System.Guid value);
        partial void OnItemIDChanged();
        partial void OnProjectIDChanging(System.Guid value);
        partial void OnProjectIDChanged();
        partial void OnCompletedChanging(bool value);
        partial void OnCompletedChanged();
        partial void OnTitleChanging(string value);
        partial void OnTitleChanged();
        partial void OnDueDateChanging(System.Nullable<System.DateTime> value);
        partial void OnDueDateChanged();
        partial void OnEstimateTimeChanging(System.Nullable<System.DateTime> value);
        partial void OnEstimateTimeChanged();
        partial void OnStatusChanging(TaskStatus value);
        partial void OnStatusChanged();
        partial void OnPriorityChanging(PriorityValue value);
        partial void OnPriorityChanged();
        #endregion

        public Task()
        {
            this._Attachment = new EntitySet<Attachment>(new Action<Attachment>(this.attach_Attachment), new Action<Attachment>(this.detach_Attachment));
            this._Projects = default(EntityRef<Project>);
            this._Status = TaskStatus.NotStarted;
            this._Priority = PriorityValue.Normal;
            this._ProjectID = new Guid(Utils.ProjectIDDefault);
            this._LocationID = new Guid(Utils.LocationIDDefault); 
            
            OnCreated();
        }

        [Column( Storage = "_Status", DbType="Int")] 
        public TaskStatus Status 
        {
            get
            {
                return _Status;  
            } 
            set 
            {               
                if ( _Status != value)
                {
                    this.OnStatusChanging(value);
                    this.SendPropertyChanging();
                    _Status = value ;
                     this.SendPropertyChanged("Status");
                    this.OnStatusChanged();
                } 
            } 
        }

        [Column(Storage = "_Priority", DbType = "Int")] 
        public PriorityValue Priority
        {
            get
            {
                return _Priority;
            }
            set
            {
                if (_Priority != value)
                {
                    this.OnPriorityChanging(value);
                    this.SendPropertyChanging();
                    _Priority = value;
                    this.SendPropertyChanged("Priority");
                    this.OnPriorityChanged();
                }
            } 
        }

        [Column(Storage = "_ItemID", DbType = "UniqueIdentifier NOT NULL", IsPrimaryKey = true)]
        public System.Guid Id
        {
            get
            {
                return this._ItemID;
            }
            set
            {
                if ((this._ItemID != value))
                {
                    this.OnItemIDChanging(value);
                    this.SendPropertyChanging();
                    this._ItemID = value;
                    this.SendPropertyChanged("Id");
                    this.OnItemIDChanged();
                }
            }
        }

        [Column(Storage = "_ProjectID", DbType = "UniqueIdentifier NOT NULL")]
        public System.Guid ProjectID
        {
            get
            {
                return this._ProjectID;
            }
            set
            {
                if ((this._ProjectID != value))
                {
                    if (this._Projects.HasLoadedOrAssignedValue)
                    {
                        throw new System.Data.Linq.ForeignKeyReferenceAlreadyHasValueException();
                    }
                    this.OnProjectIDChanging(value);
                    this.SendPropertyChanging();
                    this._ProjectID = value;
                    this.SendPropertyChanged("ProjectID");
                    this.OnProjectIDChanged();
                }
            }
        }

        [Column(Storage = "_LocationID", DbType = "UniqueIdentifier")]
        public System.Guid LocationID
        {
            get
            {
                return this._LocationID;
            }
            set
            {
                if ((this._LocationID != value))
                {                    
                   
                    this.SendPropertyChanging();
                    this._LocationID = value;
                    this.SendPropertyChanged("LocationID");
                        
                }
            }
        }

        [Column(Storage = "_Completed", DbType = "Bit NOT NULL")]
        public bool Completed
        {
            get
            {
                return this._Completed;
            }
            set
            {
                if ((this._Completed != value))
                {                 
                    this.OnCompletedChanging(value);
                    this.SendPropertyChanging();
                    this._Completed = value;
                    this.SendPropertyChanged("Completed");
                    this.OnCompletedChanged();
                }
            }
        }

        [Column(Storage = "_Title", DbType = "NVarChar(100) NOT NULL", CanBeNull = false)]
        public string Title
        {
            get
            {
                return this._Title;
            }
            set
            {
                if ((this._Title != value))
                {
                    this.OnTitleChanging(value);
                    this.SendPropertyChanging();
                    this._Title = value;
                    this.SendPropertyChanged("Title");
                    this.OnTitleChanged();
                }
            }
        }

        [Column(Storage = "_DueDate", DbType = "DateTime")]
        public System.Nullable<System.DateTime> DueDate
        {
            get
            {
                return this._DueDate;
            }
            set
            {
                if ((this._DueDate != value))
                {
                    this.OnDueDateChanging(value);
                    this.SendPropertyChanging();
                    this._DueDate = value;
                    this.SendPropertyChanged("DueDate");
                    this.OnDueDateChanged();
                }
            }
        }
         
        [Association(Name = "Attachment_Items", Storage = "_Attachment", ThisKey = "Id", OtherKey = "ItemID", DeleteRule = "NO ACTION")]
        public EntitySet<Attachment> Attachment
        {
            get
            {
                return this._Attachment;
            }
            set
            {
                this._Attachment.Assign(value);
                SendPropertyChanged("HasAttachments"); 
            }
        }

        public bool HasAttachments
        {
            get
            {
                try
                {
                    return false;                    
                }
                catch (Exception ex)
                {
                    System.Diagnostics.Debug.WriteLine (ex.Message); 
                    return false ;
                } 
            } 
        } 

        [Association(Name = "Project_Item", Storage = "_Projects", ThisKey = "ProjectID", OtherKey = "Id", IsForeignKey = true)]
        public Project Projects
        {
            get
            {
                return this._Projects.Entity;
            }
            set
            {
                Project previousValue = this._Projects.Entity;
                if (((previousValue != value) || (this._Projects.HasLoadedOrAssignedValue == false)))
                {
                    this.SendPropertyChanging();
                    if ((previousValue != null))
                    {
                        this._Projects.Entity = null;
                        previousValue.Items.Remove(this);
                    }
                    this._Projects.Entity = value;
                    if ((value != null))
                    {
                        value.Items.Add(this);
                        this._ProjectID = value.Id;
                    }
                    else
                    {
                        this._ProjectID = default(System.Guid);
                    }
                    this.SendPropertyChanged("Projects");
                }
            }
        }

        [Association(Name = "Items_Location", Storage = "_Location", ThisKey = "LocationID", OtherKey = "Id", IsForeignKey=true )]
        public Location Location 
        {
            get
            {
                return this._Location.Entity;
            }
            set
            {
                Location previousValue = this._Location.Entity; 
                if ( previousValue != value || this._Location.HasLoadedOrAssignedValue == false ) 
                {  
                     this.SendPropertyChanging();
                     if ((previousValue != null))
                     {
                        this._Location.Entity = null;                        
                     }
                     this._Location.Entity = value;
                     if ((value != null))
                     {                         
                         this._LocationID= value.Id;
                     }
                     else
                     {
                         this._LocationID = new Guid(Utils.LocationIDDefault); 
                     }
                     this.SendPropertyChanged("Location");
                     this.SendPropertyChanged("LocationID"); 
                 }
            }
        }    

        public event PropertyChangingEventHandler PropertyChanging;

        public event PropertyChangedEventHandler PropertyChanged;

        protected virtual void SendPropertyChanging()
        {
            if ((this.PropertyChanging != null))
            {
                this.PropertyChanging(this, emptyChangingEventArgs);
            }
        }

        public virtual void SendPropertyChanged(String propertyName)
        {
            if ((this.PropertyChanged != null))
            {
                this.PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }

        private void attach_Attachment(Attachment entity)
        {
            this.SendPropertyChanging();
            entity.Items = this;
        }

        private void detach_Attachment(Attachment entity)
        {
            this.SendPropertyChanging();
            entity.Items = null;
        }
    }

    [Table( Name="Projects")]
    public partial class Project: INotifyPropertyChanging, IPropertyChangedNotifier, ITodoTable 
    {

        private static PropertyChangingEventArgs emptyChangingEventArgs = new PropertyChangingEventArgs(String.Empty);

        private System.Guid _ProjectID;

        private string _Name;

        private string _Description;

        private string _Color;

        private EntitySet<Task> _Items;
        private DefaultDueDate _DefaultDueDate;
        private PriorityValue _DefaultPriority; 

        #region Extensibility Method Definitions
        partial void OnLoaded();
        partial void OnValidate(System.Data.Linq.ChangeAction action);
        partial void OnCreated();
        partial void OnProjectIDChanging(System.Guid value);
        partial void OnProjectIDChanged();
        partial void OnNameChanging(string value);
        partial void OnNameChanged();
        partial void OnDescriptionChanging(string value);
        partial void OnDescriptionChanged();
        partial void OnColorChanging(string value);
        partial void OnColorChanged();
        partial void OnDefaultDueDateChanging(DefaultDueDate value);
        partial void OnDefaultDueDateChanged();
        partial void OnDefaultPriorityChanging(PriorityValue value);
        partial void OnDefaultPriorityChanged();
        #endregion

        public Project()
        {
            this._Items = new EntitySet<Task>(new Action<Task>(this.attach_Items), new Action<Task>(this.detach_Items));
            this._DefaultPriority = PriorityValue.Normal;
            OnCreated();
        }

        [Column(Storage = "_ProjectID", DbType = "UniqueIdentifier NOT NULL", IsPrimaryKey = true)]
        public System.Guid Id
        {
            get
            {
                return this._ProjectID;
            }
            set
            {
                if ((this._ProjectID != value))
                {
                    this.OnProjectIDChanging(value);
                    this.SendPropertyChanging();
                    this._ProjectID = value;
                    this.SendPropertyChanged("Id");
                    this.OnProjectIDChanged();
                }
            }
        }

        [Column(Storage = "_Name", DbType = "NVarChar(50) NOT NULL", CanBeNull = false)]
        public string Name
        {
            get
            {
                return this._Name;
            }
            set
            {
                if ((this._Name != value))
                {
                    this.OnNameChanging(value);
                    this.SendPropertyChanging();
                    this._Name = value;
                    this.SendPropertyChanged("Name");
                    this.OnNameChanged();
                }
            }
        }

        [Column(Storage = "_Description", DbType = "NVarChar(255)")]
        public string Description
        {
            get
            {
                return this._Description;
            }
            set
            {
                if ((this._Description != value))
                {
                    this.OnDescriptionChanging(value);
                    this.SendPropertyChanging();
                    this._Description = value;
                    this.SendPropertyChanged("Description");
                    this.OnDescriptionChanged();
                }
            }
        }

        [Column(Storage = "_Color", DbType = "NVarChar(9) NOT NULL", CanBeNull = false)]
        public string Color
        {
            get
            {
                return this._Color;
            }
            set
            {
                if ((this._Color != value))
                {
                    this.OnColorChanging(value);
                    this.SendPropertyChanging();
                    this._Color = value;
                    this.SendPropertyChanged("Color");
                    this.OnColorChanged();
                }
            }
        }

        [Association(Name = "Project_Item", Storage = "_Items", ThisKey = "Id", OtherKey = "ProjectID", DeleteRule = "NO ACTION")]
        public EntitySet<Task> Items
        {
            get
            {
                return this._Items;
            }
            set
            {
                this._Items.Assign(value);
            }
        }

        
        [Column(Storage="_DefaultDueDate", DbType="int")]
        public DefaultDueDate DefaultDueDate 
        { 
            get 
            { 
                return _DefaultDueDate; 
            } 
            set 
            { 
                if ((this._DefaultDueDate!= value))
                {
                    this.OnDefaultDueDateChanging(value);
                    this.SendPropertyChanging();
                    this._DefaultDueDate = value;
                    this.SendPropertyChanged("DefaultDueDate");
                    this.OnDefaultDueDateChanged();
                } 
            } 
        }

        [Column(Storage = "_DefaultPriority", DbType = "int")]
        public PriorityValue DefaultPriority
        {
            get
            {
                return _DefaultPriority;
            }
            set
            {
                if ((this._DefaultPriority != value))
                {
                    this.OnDefaultPriorityChanging(value);
                    this.SendPropertyChanging();
                    this._DefaultPriority = value;
                    this.SendPropertyChanged("DefaultPriority");
                    this.OnDefaultPriorityChanged();
                }
            }
        }
         
        public event PropertyChangingEventHandler PropertyChanging;

        public event PropertyChangedEventHandler PropertyChanged;

        protected virtual void SendPropertyChanging()
        {
            if ((this.PropertyChanging != null))
            {
                this.PropertyChanging(this, emptyChangingEventArgs);
            }
        }

        public virtual void SendPropertyChanged(String propertyName)
        {
            if ((this.PropertyChanged != null))
            {
                this.PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }

        private void attach_Items(Task entity)
        {
            this.SendPropertyChanging();
            entity.Projects = this;
        }

        private void detach_Items(Task entity)
        {
            this.SendPropertyChanging();
            entity.Projects = null;
        }
    }

    public class PropertyChangedBase : INotifyPropertyChanged, INotifyPropertyChanging
    {
        public event PropertyChangedEventHandler PropertyChanged;

        public void NotifyPropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }

        public event PropertyChangingEventHandler PropertyChanging;

        public void NotifyPropertyChanging(string propertyName)
        {
            if (PropertyChanging != null)
            {
                PropertyChanging(this, new PropertyChangingEventArgs(propertyName));
            }
        }
    }

    //DEMOSTOP#1 
    [Table( Name="Locations")]
    [Index(Columns = "Id")]
    public class Location : PropertyChangedBase, ITodoTable 
    {
        #region Private Members
        Guid id;
        string name;
        string city;
        string zipCode;
        string state;  
        string address;
        double latitude;
        double longitude;
        string description; 
        
        #endregion

        public Location()
        {
             
        }

         
        [Column (DbType = "UniqueIdentifier NOT NULL", IsPrimaryKey = true)]
        public Guid Id
        {
            get
            {
                return id;
            }
            set
            {
                NotifyPropertyChanging("Id");
                id = value;
                NotifyPropertyChanged("Id");
            }
        }
       
        [Column]
        public string Name
        {
            get
            {
                return name;
            }
            set
            {
                if (name != value)
                {
                    NotifyPropertyChanging("Name");
                    name = value;
                    NotifyPropertyChanged("Name");
                } 
            }
        }


        [Column]
        public string Description
        {
            get
            {
                return description;
            }
            set
            {
                if (description != value)
                {
                    NotifyPropertyChanging("Description");
                    description = value;
                    NotifyPropertyChanged("Description");
                } 
            }
        }
        
       [Column]
       public string City
       {
           get
           {
               return city;
           }
           set
           {
               if (city != value)
               {
                   NotifyPropertyChanging("City");
                   city = value;
                   NotifyPropertyChanged("City");
               } 
           }
       }

       [Column]
       public string State
       {
           get
           {
               return state;
           }
           set
           {
               if (state != value)
               {
                   NotifyPropertyChanging("State");
                   state = value;
                   NotifyPropertyChanged("State");
               } 
           }
       }

       [Column]
       public string ZipCode
       {
           get
           {
               return zipCode;
           }
           set
           {
               if (zipCode != value)
               {
                   NotifyPropertyChanging("ZipCode");
                   zipCode = value;
                   NotifyPropertyChanged("ZipCode");
               } 
           }
       }


       [Column]
       public string Address
       {
           get
           {
               return address;
           }
           set
           {
               if (address != value)
               {
                   NotifyPropertyChanging("Address");
                   address = value;
                   NotifyPropertyChanged("Address");
               } 
           }
       }

      
       [Column (  ) ]
       public double Longitude
       {
           get
           {
               return longitude;
           }
           set
           {
               if (longitude != value)
               {
                   NotifyPropertyChanging("Longitude");
                   longitude = value;
                   NotifyPropertyChanged("Longitude");
               } 
           }
       }

       [Column (  ) ]
       public double Latitude
       {
           get
           {
               return latitude;
           }
           set
           {
               if (latitude != value)
               {
                   NotifyPropertyChanging("Latitude");
                   latitude = value;
                   NotifyPropertyChanged("Latitude");
               } 
           }
       }      
    } 

    /// <summary>
    /// The set of available property values.
    /// </summary>
    public enum PriorityValue
    {
        Low = 0,
        Normal = 1,        
        High = 2
    }

    /// <summary>
    /// Possible task statuses.
    /// </summary>
    public enum TaskStatus
    {
        NotStarted,
        InProgress,         
        Completed,
        Blocked,
        Deferred
    }    

    /// <summary>
    /// The set of possible default due dates for tasks created in a project.
    /// </summary>
    public enum DefaultDueDate
    {
        None,
        SameDay,
        NextDay,
        Weekend,
        MonthEnd
    }
}
#pragma warning restore 1591
