﻿// ----------------------------------------------------------------------------------
// Microsoft Developer & Platform Evangelism
// 
// Copyright (c) Microsoft Corporation. All rights reserved.
// 
// THIS CODE AND INFORMATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, 
// EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES 
// OF MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR PURPOSE.
// ----------------------------------------------------------------------------------
// The example companies, organizations, products, domain names,
// e-mail addresses, logos, people, places, and events depicted
// herein are fictitious.  No association with any real company,
// organization, product, domain name, email address, logo, person,
// places, or events is intended or should be inferred.
// ----------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;
using Microsoft.Phone.Shell;
using Todo.Misc;
using Todo.Resources;

namespace Todo.Views.Location
{
    public partial class LocationListView : TodoAppPage
    {
        public LocationListView()
        {
            InitializeComponent();
            this.DataContext = App.LocationsViewModel;
            InitializeAppBarText(); 
        }

        private void appBar_OnNewLocation(object sender, EventArgs e)
        {
            NavigationService.Navigate( UIConstants.LocationEditView ); 
        }

        protected virtual void appBar_OnSettings(object sender, EventArgs e)
        {
            base.OnAppBarSettingsClick( sender , e );  
        }


        private void InitializeAppBarText()
        {
            ((ApplicationBarIconButton)ApplicationBar.Buttons[(int)Utils.LocationListViewButtons.NewTask]).Text = ApplicationStrings.appBar_NewTask;
            ((ApplicationBarMenuItem)ApplicationBar.MenuItems[(int)Utils.LocationListViewMenuItems.Settings]).Text = ApplicationStrings.appBar_Settings;             
        }
    }


}