﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace WpfApplication1
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        //Service1 client for cloud service.
        private ServiceReference1.PushServiceClient proxy = null;

        public MainWindow()
        {
            InitializeComponent();
        }

        private void btnSend_Click(object sender, RoutedEventArgs e)
        {
            if (proxy == null)
            {
                proxy = new ServiceReference1.PushServiceClient();
            }

            proxy.SendToast(txtToastTitle.Text, txtToast.Text);
        }

        private void btnSendRaw_Click(object sender, RoutedEventArgs e)
        {
            if (proxy == null)
            {
                proxy = new ServiceReference1.PushServiceClient();
            }

            proxy.SendRaw(txtRaw.Text);
        }

        private int count = 3;

        private void btnSendTile_Click(object sender, RoutedEventArgs e)
        {
            if (proxy == null)
            {
                proxy = new ServiceReference1.PushServiceClient();
            }

            // Change the tile uri to send on each call - note that this is a local URI so the tiles are actually
            // installed on the device as content of the application. This could easily be a web URL instead.
            string tileimagename = "red.jpg";
            if (count % 3 == 1) tileimagename = "blue.jpg";
            if (count % 3 == 2) tileimagename = "green.jpg";
            proxy.SendTileUpdate(txtTile.Text, count++, new Uri(tileimagename, UriKind.Relative));
        }
    }
}
