﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;

namespace MyPushNotificationWCFServiceWebRole
{
    /// <summary>
    /// Represents device subscription.
    /// </summary>
    public class Subscription
    {
        /// <summary>
        /// Gets the user name.
        /// </summary>
        public string UserName { get; set; }

        /// <summary>
        /// Gets the notification channel uri.
        /// </summary>
        public Uri ChannelUri { get; set; }

        /// <summary>
        /// Initialize a new instance of this type.
        /// </summary>
        public Subscription(string userName, Uri channelUri)
        {
            UserName = userName;
            ChannelUri = channelUri;
        }

        /// <summary>
        /// Initialize a new instance of this type.
        /// </summary>
        public Subscription(string userName, string channelUri)
            : this(userName, new Uri(channelUri, UriKind.Absolute))
        {
        }
    }
}