﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;

using Microsoft.Phone.Tasks;
using System.Windows.Media.Imaging;

namespace PhotoSnap
{
    public partial class MainPage : PhoneApplicationPage
    {
        // Constructor
        public MainPage()
        {
            InitializeComponent();
        }

        CameraCaptureTask cameraTask = null;
        PhotoChooserTask photoChooserTask = null;


        private void photoButton_Click(object sender, RoutedEventArgs e)
        {
            if (cameraTask != null) return;

            cameraTask = new CameraCaptureTask();

            cameraTask.Completed += new EventHandler<PhotoResult>(cameraTask_Completed);

            cameraTask.Show();
        }

        void cameraTask_Completed(object sender, PhotoResult e)
        {
            if (e.TaskResult != TaskResult.OK) return;

            photoImage.Source = new BitmapImage(new Uri(e.OriginalFileName));

            cameraTask = null;
        }

        private void chooseButton_Click(object sender, RoutedEventArgs e)
        {
            if (photoChooserTask != null) return;

            photoChooserTask = new PhotoChooserTask();

            photoChooserTask.Completed += new EventHandler<PhotoResult>(photoChooserTask_Completed);

            photoChooserTask.Show();
        }

        void photoChooserTask_Completed(object sender, PhotoResult e)
        {
            if (e.TaskResult != TaskResult.OK) return;

            photoImage.Source = new BitmapImage(new Uri(e.OriginalFileName));

            photoChooserTask = null;
        }
    }
}