﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;
using System.Device.Location;

namespace MapsEmulatorTest
{
    public partial class MainPage : PhoneApplicationPage
    {
        GeoCoordinateWatcher GPSWatcher = new GeoCoordinateWatcher();
        MapDataViewModel viewModel = new MapDataViewModel();

        // Constructor
        public MainPage()
        {
            InitializeComponent();
            GPSWatcher.StatusChanged += gcw_StatusChanged;
            GPSWatcher.PositionChanged += gcw_PositionChanged;
            GPSWatcher.Start();

            MyMap.DataContext = viewModel;
            MyMap.Loaded += (s,e) => viewModel.CenterLocation();
        }

        void gcw_PositionChanged(object sender, GeoPositionChangedEventArgs<GeoCoordinate> e)
        {
            string latitude = e.Position.Location.Latitude.ToString(); 
            string longitude = e.Position.Location.Longitude.ToString(); 
            string Accuracy = e.Position.Location.HorizontalAccuracy.ToString(); 
            //Output.Items.Add(String.Format("New Lat: {0}, New Long: {1}", latitude, longitude));

            viewModel.Center = e.Position.Location;
        } 
        
        void gcw_StatusChanged(object sender, GeoPositionStatusChangedEventArgs e) 
        { 
            string status = e.Status.ToString(); 
            //Output.Items.Add(String.Format(">> New Status: {0}", status)); 
        }

        private void ButtonZoomIn_Click(object sender, RoutedEventArgs e)
        {
            viewModel.Zoom++;
        }

        private void ButtonZoomOut_Click(object sender, RoutedEventArgs e)
        {
            viewModel.Zoom--;
        }
    }
}