﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;

using Microsoft.Devices;
using Microsoft.Xna.Framework.Media;
using System.Windows.Media.Imaging;

using System.IO;
using System.IO.IsolatedStorage;

namespace AutoCamera
{
    public partial class MainPage : PhoneApplicationPage
    {
        // Constructor
        public MainPage()
        {
            InitializeComponent();
        }

        PhotoCamera camera;

        protected override void OnNavigatedTo(System.Windows.Navigation.NavigationEventArgs e)
        {
            camera = new PhotoCamera();
            //Set the VideoBrush source to the camera
            viewfinderBrush.SetSource(camera);

            camera.CaptureImageAvailable += new EventHandler<ContentReadyEventArgs>(camera_CaptureImageAvailable);
        }

        void camera_CaptureImageAvailable(object sender, ContentReadyEventArgs e)
        {
            Deployment.Current.Dispatcher.BeginInvoke(delegate()
            {
                string fileName = DateTime.Now.Ticks.ToString() + ".jpg";

                // Save picture to the device media library.
                MediaLibrary library = new MediaLibrary();

                library.SavePictureToCameraRoll(fileName, e.ImageStream);

                // Load the picture back into our image
                BitmapImage b = new BitmapImage();
                b.CreateOptions = BitmapCreateOptions.None;
                b.SetSource(e.ImageStream);
                PictureImage.Source = b;

                // Save the image into isolated storage

                using (IsolatedStorageFile isStore = IsolatedStorageFile.GetUserStoreForApplication())
                {
                    using (IsolatedStorageFileStream targetStream = isStore.OpenFile(fileName, FileMode.Create, FileAccess.Write))
                    {
                        WriteableBitmap bitmap = new WriteableBitmap(b);
                        bitmap.SaveJpeg(targetStream, bitmap.PixelWidth, bitmap.PixelHeight, 0, 100);
                    }
                }
            });
        }

        private void PhotoButton_Click(object sender, RoutedEventArgs e)
        {
            camera.CaptureImage();
        }
    }
}