﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;
using Microsoft.Phone.Tasks;
using System.Device.Location;

namespace End
{
    public partial class MainPage : PhoneApplicationPage
    {
        AddressChooserTask addressChooserTask;
        private string address;

        // Constructor
        public MainPage()
        {
            InitializeComponent();
        }

        private void btnBingDirections_Click(object sender, RoutedEventArgs e)
        {
            //Our current location
            GeoCoordinateWatcher watcher = new GeoCoordinateWatcher(GeoPositionAccuracy.High);
            watcher.MovementThreshold = 1.0; // set to one meter
            watcher.TryStart(false, TimeSpan.FromMilliseconds(1000));
            GeoCoordinate currCoord = watcher.Position.Location;

            //Directions to our contact's address
            BingMapsDirectionsTask bingMapsDirectionsTask = new BingMapsDirectionsTask();
            LabeledMapLocation start = new LabeledMapLocation();
            GeoCoordinate startLocation = currCoord;
            start.Label = "Current Location";
            start.Location = startLocation;
            LabeledMapLocation end = new LabeledMapLocation(address, null);

            bingMapsDirectionsTask.Start = start;
            bingMapsDirectionsTask.End = end;
            bingMapsDirectionsTask.Show();

        }

        private void addressChooserButton_Click(object sender, RoutedEventArgs e)
        {
            addressChooserTask = new AddressChooserTask();
            addressChooserTask.Completed += new EventHandler<AddressResult>(addressChooserTask_Completed);

            try
            {
                addressChooserTask.Show();
            }
            catch (System.InvalidOperationException ex)
            {
                // Catch the exception, but no handling is necessary.
            }

        }

        void addressChooserTask_Completed(object sender, AddressResult e)
        {
            if (e.TaskResult == TaskResult.OK)
            {
                address = e.Address;
                textBlock1.Text = "The address for " + e.DisplayName + " is :\n" + e.Address;
                directionsChooserButton.IsEnabled = true;
                directionsChooserButton.Content = "Directions to " + e.DisplayName;
            }
        }
    }
}