﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.IO;
using System.IO.IsolatedStorage;
using System.Windows.Threading;

namespace CRMapp
{
    public class DataGenerator
    {
        public const int OneObjectAvgSize = 800; // avg bytes on 1 obj

        private readonly string[] companies =
            "General Motors,Exxon Mobil,U.S. Steel,General Electric,Esmark,Chrysler,Armour,Gulf Oil,Mobil,DuPont,Amoco,Bethlehem Steel,CBS,Texaco,AT&T Technologies,Shell Oil,Kraft,ChevronTexaco,Goodyear Tire & Rubber,Boeing,Sinclair Oil,Navistar International,RCA,Union Carbide,Firestone Tire & Rubber,Douglas Aircraft,Procter & Gamble,Republic Steel,Citgo Petroleum,ConocoPhillips,General Foods,Uniroyal,Borden Chemical,Lockheed Martin,Alcoa,International Paper,Wilson,Sunoco,United Technologies,American Can,General Dynamics,Rockwell Automation,Eastman Kodak,Goodrich,Continental Group,Bendix,Atlantic Richfield,Fortune Brands,Ryerson Tull,ARMCO,Honeywell Intl.,AMAX,Conoco,Allis-Chalmers,Jones & Laughlin Steel,General Mills,National Intergroup,Curtiss-Wright,Olin,Asarco,Intl. Business Machines,Anaconda,Tidewater Oil,Cudahy,Briggs Manufacturing,Sperry,Nabisco Group Holdings,PPG Industries,Dow Chemical,Youngstown Sheet & Tube,Kennecott,NL Industries,Standard Brands,Sealed Air,Caterpillar,American Motors,Ralston Purina,American Cyanamid,Pullman,Pure Oil,BorgWarner,Nabisco Brands,Avco,Unocal,Philco,Burlington Industries Equity,Monsanto,Campbell Soup,Owens-Illinois,Pillsbury,Singer,Hormel Foods,Hygrade Food Products,Republic Aviation,Carnation,Amstar,Reynolds Metals,Morrell (John),BP America,American Standard,United Merchants & Mfrs.,Crane,Crown Zellerbach,Deere,Liggett Group,Sylvania Electric Products,J.P. Stevens,Phelps Dodge,Beatrice,Rath Packing,Martin Marietta,TRW,Quaker Oats,Weyerhaeuser,Colgate-Palmolive,NCR,Manville,Babcock & Wilcox,CF&I Steel,A.O. Smith,Marathon Oil,Foremost Dairies,Furniture Brands Intl.,ACF Industries,Otis Elevator,Coca-Cola,Rockwell-Standard,J.E. Seagram,Grumman,National Supply,3M,Honeywell,Scott Paper,Ashland,Del Monte Foods,Kaisertech,Remington Rand,FMC,Oscar Mayer,Richfield Oil,Studebaker,H.J. Heinz,Admiral,Armstrong Holdings,American Viscose,USG,GenCorp,Anheuser-Busch,Libby, McNeill & Libby,Continental Baking,Kaiser Industries,Aeroquip-Vickers,Skelly Oil,Glidden,Archer Daniels Midland,Motorola,Wyeth,International Packers,Johnson & Johnson,Quantum Chemical,St. Regis,Electric Autolite,Arden Farms,Bestfoods,Revere Copper & Brass,Hearst Consolidated Publications,Wheeling Pittsburgh,Koppers,Hercules,Alco Products,Container Corp. of America,M. Lowenstein,Bell Intercontinental,Continental Motors,Cannon Mills,Pet,Kimberly-Clark,Raytheon,Dart Industries,Wesson Oil & Snowdrift,Curtis Publishing,Schenley Industries,Northrop Grumman,Allegheny International,Whirlpool,Kellogg,Unisys,Walter Industries,Eaton,Westvaco,Sterling Drug,Mid-Continent Petroleum,Rheem Manufacturing,Gillette,Crucible Steel,Brink's,Hershey Foods,General American Transportation,Baldwin-Lima-Hamilton,Dana,Central Soya,Carrier,Grinnell,Combustion Engineering,Genesco,Chance Vought,Newport News Shipbuilding,Consolidation Coal,Corning,Celanese,Fruehauf,Merck,White Motor,International Cellucotton Products,Pfizer,Pabst Brewing,Staley Continental,Altria Group,National Sugar Refining,Cone Mills,Fairchild Engine & Airplane,Simmons,Brown Shoe,Zenith Electronics,Foster Wheeler,Studebaker-Worthington,Owens Corning,Timken,Norton,American Bakeries,Campbell Taggart,Endicott Johnson,McGraw-Edison,Rohm & Haas,Lorillard,Ingersoll-Rand,Dresser Industries,Kaiser Steel,Cletrac,Champion Papers,National Gypsum,AMF,Clinton Foods,Sunray Oil,Eastern Gas & Fuel Associates,Champion International,Pittsburgh Steel,Tecumseh Products,Kelsey-Hayes,General Precision Equipment,BOC,McDonnell Douglas,Eli Lilly,General Host,Stokely-Van Camp,Westinghouse Air Brake,American-Marietta,Mack Trucks,Sunshine Biscuits,Marathon,Keebler,Gair (Robert),Bemis,Seeger Refrigerator,Murray Corp.,Warren Petroleum,Mead,Crown Holdings,Link-Belt,Scovill,Cincinnati Milacron,Parke, Davis,Abex,Budd,Anaconda Wire & Cable,Fairbanks, Morse,CVS,Allied Mills,Bridgeport Brass,Spencer Kellogg & Sons,Union Camp,GAF,Fairmont Foods,WestPoint Stevens,Colorado Milling & Elevator,Anchor Hocking,Rohr,Garrett,Blaw-Knox,Diamond International,Schlitz Brewing,Textron,Lion Oil,Sharon Steel,Pacific Vegetable Oil,GK Technologies,Liebmann Breweries,Ward Foods,St. Joseph Lead,Flintkote,Interstate Brands,Imcera Group,Maxus Energy,Chemetron,York International,Kendall,Squibb,Stewart-Warner,Case,Ex-Cell-O,Du Mont (Allen B.) Labs.,U.S. Pipe & Foundry,Fibreboard,Clark Equipment,Plymouth Oil,Collins Radio,Sunbeam/Oster,Inmont,Amsted Industries,Abbott Laboratories,Yale & Towne Manufacturing,Servel,Long-Bell Lumber Co.,Motor Products,ITT Rayonier,Best Foods,Gaylord Container,Virginia-Carolina Chemical,Beaunit,Pepperell Manufacturing,Amerada Hess,Texasgulf,Lone Star Industries,Royal McBee,Eagle-Picher Industries,Wm. Wrigley Jr.,Stauffer Chemical,Wagner Electric,Marshall-Wells,Dan River,Keystone Consolidated Industries,Maytag,City Products,Thomas J. Lipton,Emerson Radio & Phonograph,Cluett Peabody,Hazel-Atlas Glass,Gerber Products,Great Western Sugar,Tobin Packing,Beech Aircraft,ESB,Minneapolis-Moline,Rockwell Manufacturing,Ruberoid,Paccar,Butler Manufacturing,Superior Oil,Olivetti Underwood,Certainteed,National Container,Lukens Steel,American Bosch Arma,PepsiCo,Stanley Works,New York Shipbuilding,Glen Alden,Outboard Marine,Hines (Edward) Lumber,Shoe Corp. of America,Standard Coil Products,Norris-Thermador,American Chain & Cable,Carborundum,Interlake,Riegel Textile,Todd Shipyards,Cleveland-Cliffs,Minnesota & Ontario Paper,McGraw-Hill,Pocahontas Fuel,Granite City Steel,Remington Arms,Bigelow-Sanford,H.K. Porter,Bliss (E.W.),Falstaff Brewing,I-T-E Imperial,Canada Dry,American Optical,American Agricultural Chemical,Brown Co.,Raybestos-Manhattan,Norton Simon,Hartmarx,Savannah Sugar Refining,Bucyrus-Erie,Industrial Rayon,Handy & Harman,AM International,Richardson-Vicks,US Pharmaceuticals,Interlake Iron,Solar Aircraft,Tennessee Corp.,Crowell-Collier Publishing,American Zinc, Lead & Smelting,Georgia-Pacific,International Silver,Niles-Bement-Pond,Stromberg-Carlson,Houdaille Industries,Magnavox,Joy Technologies,Joslyn Manufacturing & Supply,Kroehler Manufacturing,Joy Global,Daystrom,Bristol-Myers Squibb,Celotex,Lees (James) & Sons,Calumet & Hecia,Burrus Mills,Bibb Manufacturing,U.S. Industries,Cuban Atlantic Sugar,Dole,Elgin National Watch,Lehigh Portland Cement,American Enka,Ekco Products,LTV,Clevite,Cummins,Ideal Basic Industries,Robertshaw Controls,American Forest Products,Pennwalt Corp,United Engineering & Foundry,Atlas Powder,Harbison-Walker Refractories,Lily-Tulip Cup,Freeport Sulphur,Gould-National Batteries,Mohasco,Times Mirror,National Automotive Fibers,Stanley Home Products,Continental Foundry & Machine,Dayco,Square D,Publicker Industries,Armstrong Rubber,Godchaux Sugars,Avon Products,Carey (Philip) Manufacturing,Anderson-Prichard Oil,Midland-Ross,P.R. Mallory,Consolidated Papers,Oxford Paper,Lear,Cutler-Hammer,Sutherland Paper,Gilfillan Bros.,USM,Bates Manufacturing,Motor Wheel,Reeves Brothers,Congoleum,Harshaw Chemical,Young (L.A.) Spring & Wire,Barium Steel,Arvin Industries,Climax Molybdenum,Erwin Mills,S & W Fine Foods,Columbian Carbon,South Penn Oil,National Homes,Crown Central,Udylite,Bird & Son,Detroit Steel,Mullins Manufacturing,Commercial Solvents,Fuller Brush,Liquid Carbonic,Consolidated Cigar,Langendorf United Bakeries,Truax-Traer Coal,Mansfield Tire & Rubber,Blue Bell,Warner-Lambert,Trane,Signal Oil Gas,Bullard,Cuban-American Sugar,Goodall-Sanford,Copperweld Steel,Ford Motor,ITT Industries,Merritt-Chapman & Scott,Sunray DX Oil,McLouth Steel,Minute Maid,Automatic Canteen,Hooker Chemical,Federal-Mogul,Coltec Industries,Island Creek Coal,Bulova Watch,Cerro,National Can,Mueller Brass,Berkshire Hathaway,Ceco Industries,American Metal Products,Chicago Pneumatic Tool,Suntide Refining,Consolidated Coppermines,Premcor,Natl. Malleable & Steel Castings,Alan Wood Steel,Laclede Steel,Briggs & Stratton,Visking,Vertol Aircraft,Bohn Aluminum & Brass,Vanadium,Graniteville Co.,Pittsburgh Coke & Chemical,General Refractories,Champlin Oil & Refining,Great Northern Paper,Sheller Manufacturing,Holly Sugar,Weatherhead,Warren (S.D.),Ogden,GATX,R.R. Donnelley & Sons,Material Service,Peabody Coal,Southern States Cooperative,U.S. Hoffman Machinery,Lone Star Steel,Revlon,Walworth,Wyandotte Chemicals,Philadelphia & Reading,Harsco,Northwestern Steel & Wire,Continental Copper & Industries,Kayser (Julius),Cessna Aircraft,Sundstrand,Fedders,Reliance Electric,Gardner-Denver,Western Publishing Group,Hupp,Carpenter Technology,Masonite,Cooper-Bessemer,Lever Brothers,Sherwin-Williams,IPL,Springs Industries,Brunswick,Farmland Industries,Kerr-McGee,Botany Industries,Vulcan Materials,New York Times,Potlatch,Eastern States Farmers' Exch.,Schering-Plough,Danly Machine Specialties,Fuller (W.P.),Ryan Aeronautical,Cosden Petroleum,Signal Companies,Flour Mills of America,McCall,Delhi-Taylor Oil,Texas Instruments,Mesta Machine,Emerson Electric,Reichhold Chemicals,Globe-Union,Akzona,Chemstrand,Pharmacia,Champion Spark Plug,Thiokol,Safety-Kleen,Cyclops Industries,Litton Industries,Hanna Mining,Federal Paper Board,Lear Siegler,OfficeMax,American Petrofina,Standard Kollsman Industries,Permanente Cement,Evans Products,Vitro Corp. of America,Polaroid,Grolier Society,Standard Pressed Steel,American Chicle,Hudson Pulp & Paper,Miles Laboratories,Standard Packaging,Riegel Paper,General Telephone & Electronics,Engelhard Industries,Trans Union,Kayser-Roth,Di Giorgio,Inland Container,North American Philips,Howmet,Seaboard,Friden,Tappan,Tung-Sol Electric,Universal Match,Agway,Packaging Corp. of America,KVP Sutherland Paper,Bell & Howell,Mead Johnson,Federal Pacific Electric,Kern County Land,Witco,Yuba Consolidated Industries,Miehle-Goss-Dexter,Union Texas Natural Gas,Indian Head,Purex Industries,Hammermill Paper,Commonwealth Oil Refining,Spencer Chemical,Harris,Grolier,Robertson-Ceco,Maremont,Jos. Schlitz Brewing,Stanley Warner,Frito-Lay,Castle & Cooke,Murphy Oil,Chesebrough-Pond's,Fairchild Camera & Instrument,Woodward Iron,Kellwood,Harvey Aluminum,Hewlett-Packard,Emhart,General Steel Industries,American Biltrite Rubber,Atlas Chemical Industries,Robertshaw-Fulton Controls,Flavorland Industries,Marquette Cement Manufacturing,Sprague Electric,Hobart,Pitney Bowes,Eltra,Land O'Lakes,Ethyl,Cowles Communications,International Pipe & Ceramics,Xerox,Cabot,Air Products & Chem.,MacMillan,Amphenol-Borg Electronics,Collins & Aikman,Bond Stores,Fieldcrest Cannon,General Instrument,Duncan Foods,Ampex,Intl. Multifoods,Universal American,Iowa Beef Processors,FINA,Pacolet Industries,Farmers Union Central Exchange,Jonathan Logan,Rexnord,U.S. Shoe,Insilco,Cooper Industries,Hess Oil & Chemical,Hoover,Essex International,Time Warner,CBI Industries,Control Data,Koehring,Warwick Electronics,Roper,Electrolux,Alberto-Culver,Black & Decker,Nebraska Consolidated Mills,Draper,Tenneco Automotive,Cotton Producers Association,Gulf & Western Industries,Apogent Technologies,Warnaco Group,U.S. Smelting, Refining & Mining,Morton International,Hoover Universal,Rheingold,Coastal,Dorr-Oliver,Green Giant,Fairchild Industries,Warner & Swasey,Brockway,Hanes,Bunker Ramo,AMP,Signode,Kidde,Teledyne,Brown,Household Manufacturing,Heublein,White Consolidated Industries,Dean Foods,National Union Electric,Varian Associates,Phillips-Van Heusen,Hoerner Waldorf,Sheller-Globe,Bangor Punta,Becton Dickinson,B.V.D.,Parker Hannifin,Sara Lee,Getty Oil,Chiquita Brands Intl.,Occidental Petroleum,A-T-O,Whittaker,Questor,Norris Industries,General Signal,Spencer Foods,ConAgra Foods,Avnet,Hyster,Victor Comptometer,Sanders Associates,Max Factor,Great Northern Nekoosa,G.D. Searle,Itek,Fruit of the Loom,International Utilities,Universal Oil Products,National Industries,Diversified Industries,Great Western United,Metromedia International,City Investing,Levi Strauss,Allied Products,Wean United,Microdot,Automation Industries,Amerace Esna,Johnson Service,Mattel,Commonwealth United,National Presto Industries,Applera,F. & M. Schaefer,AMBAC Industries,Lubrizol,American Beef Packers,Triangle Industries,Rapid-American,Lykes,Whitman,Loews,Gould,Ikon Office Solutions,National Service Industries,Chromalloy American,NVF,MBPXL,DeSoto,Republic,Tyco Laboratories,Commercial Metals,Penn-Dixie Industries,VF,Interpace,Easco,Skyline,American Hoist & Derrick,Ludlow,Willamette Industries,Instrument Systems,Nekoosa-Edwards Paper,Peter Eckrich & Sons,Knight-Ridder,Monfort of Colorado,Greyhound,Anderson Clayton,Gold Kist Holdings,Dairylea Cooperative,Talley Industries,Kane-Miller,Armour-Dial,Newmont Mining,Baxter International,Arcata,E.T. Barwick Industries,Capitol Industries,Pneumo Dynamics,Nalco Chemical,Athlone Industries,Associated Milk Producers,American Broadcasting,Universal Leaf Tobacco,Warner Communications,Figgie International,UV Industries,MCA,Saxon Industries,Gannett,Columbia Pictures Industries,Southwest Forest Industries,Cyprus Amax Minerals,St. Joe Minerals,Washington Post,Cenco,Purolator,Matan Industries,Williams,Peavey,Bluebird,Fleetwood Enterprises,Omega-Alpha,Marathon Manufacturing,Redman Industries,Scott & Fetzer,Idle Wild Foods,Riviana Foods,McDonough,Utah International,Champion Home Builders,Ferro,Pennzoil,Charter,Louisiana-Pacific,Clorox,Dover,International Foodservice Systems,Tesoro,Cook Industries,Digital Equipment,Coca-Cola Bottling Co. of New York,Acco Industries,Wheelabrator-Frye,Twentieth Century-Fox Film,Sequa,General Cinema,Avery Dennison,Sperry & Hutchinson,Alumax,Westmoreland Coal,Savannah Foods & Industries,Tosco,Southern Industries,Copperweld,General Infractories,C. Brewer,Nashua,Belco Petroleum,Amtel,Bausch & Lomb,Southdown,Olinkraft,United Refining,Tyler,Peabody Holding,Molson Coors Brewing,Baker Hughes,Hunt International Resources,CF Industries,SuCrest,Consolidated Aluminum,H.P. Hood,Ball,Envirotech,Cameron Iron Works,Kewanee Industries,Hughes Tool,Mapco,Tektronix,International Systems & Controls,Masco,Foxboro,Peabody International,Ecolab,Marmon Group,Norin,Quaker State,Natomas,U.S. Filter,Frederick & Herrud,Dow Corning,Louisiana Land & Exploration,Memorex Telex,National Starch & Chemical,Interstate Bakeries,Pacific Resources,National Semiconductor,PerkinElmer,Maryland Cup,Johnson Controls,Midland Cooperatives,Harcourt Brace Jovanovich,Dennison Manufacturing,McCormick,Fiat-Allis,Smith International,Big Three Industries,Coca-Cola Bottling,Intel,Thorn Apple Valley,Royal Crown Companies,Data General,Union Pacific,McDermott,G. Heileman Brewing,Gulf Resources & Chemical,Freeport-McMoran,Storage Technology,Moore McCormack Resources,Dexter,Dow Jones,Barnes Group,Nucor,Wyman-Gordon,Beckman Coulter,Sonoco Products,Dorsey,Metromedia,Stanadyne,Capital Cities/ABC,Kohler,Magic Chef,Penn Central,Crouse-Hinds,Bally Manufacturing,Dorchester Gas,Marley,Gifford-Hill,Wang Laboratories,Trinity Industries,Natl. Coop. Refinery Assn.,Raychem,Mitchell Energy & Devel.,Intl. Flavors & Frag.,BATUS,Engelhard,Hoechst Celanese,Farmers Union Central Exch.,MID-AMERICA DAIRYMEN,BASF,Geosource,E-SYSTEMS,Gates Learjet,Fort James,Armtek,L.B. Foster,M/A-Com,Oak Industries,Titanium Metals Corp. of America,Deluxe,Tyson Foods,Brown-Forman,Palm Beach,Mallinckrodt,American Greetings,Kerr Glass Manufacturing,Fort Howard,Georgia Kraft,Research-Cottrell,Ampco-Pittsburgh,Marion,Knudsen,Illinois Tool Works,Shaklee,Sipco,Wilson Foods,Tribune,Mobay,Hanson Industries NA,Apple Computer,Tyco International,Holly,Dr Pepper/Seven-Up,Sun-Diamond Growers,Coleco Industries,Datapoint,MEI,Universal Foods,Echlin,North American Coal,A.H. Robins,AMDAHL,Flowers Industries,Meredith,Liquid Air,Wisconsin Dairies Cooperative,Worthington Industries,Oxford Industries,DR Holdings Inc. of Delaware,Snap-On,Cooper Tire & Rubber,Media General,Diebold,Stone Container,Ametek,Lafarge,Inspiration Resources,NI Industries,Badische,Gulfstream Aerospace,Smithfield Foods,Michigan Milk Prod. Assoc.,ROLM,Coachmen Industries,Rhone-Poulenc Rorer,Guardian Industries,Cooper Labs,Prentice-Hall,Harte-Hanks Communications,Bairnco,Rubbermaid,Hillenbrand Industries,Hubbell,Pittway,H.B. Fuller,SPX,Tracor,Tandem Computers,AT&T,Temple-Inland,Weirton Steel,Hasbro,Smurfit-Stone Container,Esselte Business Systems,Advanced Micro Devices,Computervision,Pentair,Carlisle,Nortek,Longview Fibre,Nacco Industries,Nerco,Harris Graphics,Ocean Spray,Coleman,Shaw Industries,Winn Enterprises,UST,Jostens,Management Assistance,Leggett & Platt,Katy Industries,Medtronic,Lancaster Colony,Loral,C.R. Bard,Lukens,Valero Energy,Texas Oil & Gas,Minstar,Triarc,Bowater,First City Industries,AG Processing,Metaldyne,Liz Claiborne,Riceland Foods,SCI Systems,California & Hawaiian Sugar,Compaq Computer,Herman Miller,HNI,Dataproducts,Philips Industries,Chesapeake,Commerce Clearing House,Standard Register,Scientific-Atlanta,S.S. Pierce,American Maize-Products,Winnebago Industries,Bayer Corporation,Premark International,Union Texas,Himont,Chicago Pacific,International Controls,Texas Industries,Calmat,Intergraph,Cray Research,Kaman,Anchor Glass Container,Georgia Gulf,Leslie Fay,Cooper Cos.,Vista Chemical,Danaher,Kenner Parker Toys,Amalgamated Sugar,Diamond-Bathurst,Tambrands,Seagate Technology,ATCOR,Clevite Industries,Millipore,Noxell,Russell,Standard Products,Xidex,Allen Group,Bassett Furniture Industries,Rochester & Pittsburgh Coal,Coca-Cola Enterprises,Universal,Knoll International Holdings,Aristech Chemical,Fisher Scientific Group,Allegheny Technologies,Newell Rubbermaid,Harley-Davidson,Magnetek,Henley Manufacturing,Avery,Sealy,Marion Laboratories,Dixie Yarns,Reynolds & Reynolds,Harvard Industries,Apollo Computer,Guilford Mills,Sun Microsystems,Jepson,Faberge,Toro,Grow Group,Great Lakes Chemical,Atari,Homestake Mining,Affiliated Publications,AFG Industries,Kimball International,Envirodyne Industries,Sprague Technologies,A. Schulman,Western Digital,M.A. Hanna,Unilever U.S.,Henley Group,National Steel,Valhi,Burlington Resources,Diamond Shamrock,E.W. Scripps,Standard Commercial,Rexene,Sterling Chemicals,Lone Star Technologies,Imo Industries,SSMC,Valmont Industries,LPL Technologies,Finevest Foods,Magma Copper,Miniscribe,Avondale Industries,P.H. Glatfelter,Constar International,UIS,DIMON,Borden Chemicals & Plastics,Fairchild,J.P. Industries,Sudbury,Banta,Maxxam,Pope & Talbot,Thomas & Betts,Prairie Farms Dairy,Pilgrim's Pride,Molex,NCH,Chemed,Lyondell Chemical,Uniroyal Goodrich Tire,Reader's Digest Assn.,Great American Mgmt. & Inv.,Amoskeag,Duracell International,Oryx Energy,IMC Global,First Brands,Foodbrands America,Essex Group,Terex,Crystal Brands,J&L Specialty Steel,Dresser-Rand,JPS Textile Group,Tri Valley Growers,Mark IV Industries,Exide Technologies,Anacomp,Conner Peripherals,Lincoln Electric Holdings,Imperial Sugar,St. Joe Paper,Tredegar Industries,Helene Curtis Industries,Gitano Group,Hudson Foods,Thermo Electron,Interface,Stanhome,Delta Woodside Industries,La-Z-Boy,LSI Logic,Level 3 Communications,Alliant Techsystems,Domino Sugar,Holnam,Mueller Industries,Allergan,Wellman,Uniroyal Chemical,Tonka,Horsehead Industries,Silgan Holdings,Quanex,Zurn Industries,Stewart & Stevenson Svcs.,Baroid,Betz Laboratories,Bandag,Kennametal,Pall,Applied Materials,Valspar,Carter-Wallace,Loctite,Goulds Pumps,Albany International,Harman Intl. Industries,Total Petroleum,Brooke Group,Quantum,Maxtor,United States Surgical,Du Pont Merck Pharmaceutical,Amgen,AST Research,Huffy,Blount,Arcadian,Ply Gem,Silicon Graphics,Dell,First Mississippi,Analog Devices,Precision Castparts,Standard Motor Products,Block Drug,IBP,Varity,Ultramar Diamond Shamrock,CENEX,Gateway,J.M. Huber,Unifi,Primedia,Kendall International,Tyco Toys,Fisher-Price,Valassis Communications,Vishay Intertechnology,Sigma-Aldrich,Oshkosh Truck,Specialty Coatings International,Giddings & Lewis,Security Benefit,Vector Group,Carpenter,Praxair,Detroit Diesel,PolyOne,General Cable,Solectron,Micron Technology,EMC,DSC Communications,BayNetworks,Foamex International,Oregon Steel Mills,Teleflex,Universal Forest Prods.,Cisco Systems,Ivax,ACX Technologies,RPM International,3Com,WLR Foods,Wal-Mart Stores,Sears Roebuck,State Farm Insurance Cos,Prudential Ins. Co. of America,Kmart Holding,Citicorp,Kroger,American Intl. Group,MetLife,Target,J.C. Penney,GTE,United Parcel Service,Fannie Mae,Citigroup,Cigna,American Stores,Merrill Lynch,Aetna,BellSouth,BankAmerica Corp.,Costco Wholesale,AMR,Supervalu,Fleming,Safeway,American Express,UAL,Verizon Communications,MCI Communications,Nynex,Bank of America Corp.,Chase Manhattan Corp.,Sprint,Ameritech,Home Depot,McKesson,Delta Air Lines,May Dept. Stores,New York Life Insurance,J.P. Morgan,Albertson's,SBC Communications,MediaOne Group, Inc.,Nationwide,Columbia/HCA Healthcare,Winn-Dixie Stores,Sysco,Teachers Insurance & Annuity Assn.,PG&E Corp.,Great Atlantic & Pacific Tea,Waste Management,Walt Disney,CSX,Northwestern Mutual,Pacific Telesis Group,Morgan Stanley Group,Walgreen,Lehman Brothers Hldgs.,Northwest Airlines,Liberty Mutual Ins. Group,Enron,Toys `R` Us,Publix Super Markets,Massey Energy,FedEx,Sodexho Marriott Services,Edison International,McDonald's,Federated Dept. Stores,Southern,Foot Locker,Principal Financial,Bank One Corp.,Viacom,Bankers Trust Corp.,Bergen Brunswig,Limited Brands,Supermarkets Genl. Holdings,US Airways Group,Lincoln National,Freddie Mac,Morgan Stanley,AXA Financial,Salomon,Unicom,Wachovia Corp.,Consolidated Edison,USAA,Guardian Life of America,AFLAC,Lowe's,Wells Fargo,Entergy,Public Service Enterprise Group,Cardinal Health,Halliburton,Dillard's,Chubb,Continental Airlines,John Hancock Financial Svcs.,TXU,American Electric Power,FPL Group,Avatex,KeyCorp,Transamerica,Mass. Mutual Life Ins.,Continental,Aramark,First Chicago Corp.,Merisel,Vons,Burlington No. Santa Fe,Wells Fargo & Co.,RadioShack,Tele-Communications,R.H. Donnelley,Genuine Parts,American General,St. Paul Travelers Cos.,Ryder System,PNC Financial Services,CNF,Arrow Electronics,Microsoft,Household International,PanEnergy,Norfolk Southern,Caliber System,Eckerd,BankBoston Corp.,Dominion Resources,Duke Energy,FleetBoston Financial,Rite Aid,Eastman Chemical,Browning-Ferris Industries,AmerisourceBergen,Manpower,Office Depot,Bank of New York Co.,First Interstate Bancorp,Aon,Niagara Mohawk Holdings,Circuit City Stores,Service Merchandise,Exelon,Bindley Western,CenterPoint Energy,Mutual of Omaha Ins.,Paine Webber Group,Mellon Financial Corp.,Nordstrom,TJX,Dole Food,General Re,Nike,Stop & Shop,UnitedHealth Group,Conrail,Gap,Humana,HomeBase, Inc.,GPU,Northeast Utilities,Harcourt General,Unum,Central & South West,CMS Energy,Giant Food,Safeco,Viad,Denny's,DTE Energy,Wellpoint,PacifiCorp,First Chicago NBD Corp.,Tenet Healthcare,Bear Stearns,Marsh & McLennan,Trans World Airlines,H.F. Ahmanson,Thrifty PayLess Holdings,Penn Traffic,Reebok International,Allmerica Financial,SunTrust Banks,USF&G,Centex,Southern Pacific Rail,Fred Meyer,Intelligent Electronics,Barnett Banks,Long Island Lighting,SLM,Reliance Group Holdings,Consolidated Natural Gas,W.W. Grainger,Spiegel,Best Buy,Great Western Financial Corp.,ServiceMaster,Beverly Enterprises,Smith's Food & Drug Centers,U.S. Healthcare,HealthTrust,Alltel,Providian,Santa Fe Pacific,Cinergy,National City Corp.,PacifiCare Health Sys.,Progress Energy,Yellow Roadway,Bruno's,Columbia Energy Group,Nash Finch,Mercantile Stores,Transco Energy,Turner Broadcasting,NorAm Energy,APL,Constellation Energy,Florida Progress,UnumProvident,Caldor,Thrivent Financial for Lutherans,Payless Cashways,PPL,GEICO,Pacific Enterprises,Turner Corp.,United States Shoe,Southwest Airlines,Food 4 Less,Computer Sciences,True Value,Republic New York Corp.,Comerica,Longs Drug Stores,First Fidelity Bancorp.,Revco D.S.,Morrison Knudsen,CoreStates Financial Corp.,Xcel Energy,Grand Union Holdings,FHP International,Automatic Data Proc.,Roundy's,Hechinger,Allegheny Energy,Caremark International,Centerior Energy,Tech Data,Progressive,Owens & Minor,American Medical Holdings,U.S. Bancorp,FirstEnergy,Graybar Electric,Kelly Services,Ace Hardware,Shawmut National Corp.,Health Net,Boatmen's Bancshares,Hannaford Bros.,Olsten,Phoenix,New England Electric Sys.,New England Mutual Life Ins.,Lutheran Brotherhood,MicroAge,MCI WorldCom,First Data,Allstate,Hartford Financial Services,College Retirement Equities Fund,ITT,Dynegy,American Financial Grp.,Circle K,Comcast,Pacific Life,WellPoint Health Networks,Staples,Oracle,Jacuzzi Brands,Estee Lauder,Conseco,CompUSA,Aquila,Computer Assoc. Intl.,MBNA,Spartan Stores,Golden West Financial,Foundation Health,State St. Corp.,Ingram Micro,Millennium Chemicals,Caremark Rx,Allegiance,Hilton Hotels,LG&E Energy,Washington Mutual,Sonat,American Family Ins. Grp.,Richfood Holdings,Darden Restaurants,InaCom,Oxford Health Plans,El Paso,Beneficial,GenAmerica,Big Lots,Omnicom Group,Western Atlas,Ventas,TIAA-CREF,Lucent Technologies,Electronic Data Systems,AutoNation,Unisource,Cendant,CHS Electronics,ProSource,AirTouch Communications,Saks,Rykoff-Sexton,New Century Energies,BJ's Wholesale Club,AGCO,Corporate Express,Ameren,Interpublic Group,Kohl's,HealthSouth,Airborne,U.S. Office Products,Comdisco Holding,Anixter International,Barnes & Noble,US West,Yum Brands,Marriott International,Nebco Evans,Sempra Energy,U.S. Foodservice,Starwood Hotels & Rsrts.,Science Applications Intl.,Kinder Morgan,KeySpan,Meritor Automotive,Avista,Host Marriott,Autoliv,Peter Kiewit Sons',Charles Schwab,Qualcomm,Cablevision Systems,AutoZone,United States Filter,Dollar General,Sun Healthcare Group,Kindred Healthcare,Regions Financial,Conectiv,United Stationers,United Auto Group,Golden State Bancorp,Wesco International,Lexmark International,BB&T Corp.,ShopKo Stores,Integrated Health Services,SouthTrust Corp.,Mercantile Bancorp.,NiSource,Bell Atlantic,Prudential Financial,Goldman Sachs Group,Texas Utilities,Fluor,Associates First Capital,Reynolds American,Foundation Health Systems,CHS,America Online,Crestline Capital,MidAmerican Energy Holdings,Express Scripts,AK Steel Holding,Providian Financial,Adams Resources & Engy.,Countrywide Financial,Capital One Financial,Qwest Communications,Ames Dept. Stores,KB Home,AmSouth Bancorp.,Pulte Homes,Fifth Third Bancorp,Sonic Automotive,Allied Waste Industries,Avis Rent A Car,Nextel Communications,Service Corp. Intl.,AES,IAC/Interactive,Plains Resources,Caesars Entertainment,Interim Services,Jones Apparel Group,D.R. Horton,Lennar,Mohawk Industries,Budget Group,TransMontaigne,ReliaStar Financial,Delphi,Pepsi Bottling,NorthWestern,ONEOK,CIT Group,Anadarko Petroleum,Clear Channel Communications,USA Education,Encompass Services,Sanmina-SCI,CDW,Pathmark Stores,Spherion,Administaff,Pinnacle West Capital,Group 1 Automotive,Jabil Circuit,Northern Trust Corp.,Cox Communications,Harrah's Entertainment,Emcor Group,Puget Energy,SCANA,Quest Diagnostics,Jacobs Engineering Grp.,Tellabs,Wisconsin Energy,Steelcase,Hughes Supply,OGE Energy,Borders Group,ADC Telecommunications,Western Gas Resources,Charter Communications,Lennox International,Summit Bancorp,Jefferson-Pilot,MGM Mirage,Pennzoil-Quaker State,Mirant,Visteon,Agilent Technologies,Calpine,AdvancePCS,Plains All Amer. Pipeline,Avaya,Idacorp,Sierra Pacific Resources,Echostar Communications,Fidelity National Financial,Energy East,NTL Europe,First American Corp.,Family Dollar Stores,Adelphia Communications,Core-Mark International,Performance Food Group,JDS Uniphase,NSTAR,Staff Leasing,Enterprise Products,Coventry Health Care,Union Planters Corp.,Equity Office Properties,Amazon.Com,American Axle & Mfg.,C.H. Robinson Worldwide,Devon Energy,J.P. Morgan Chase & Co.,HCA,AT&T Wireless Services,Reliant Energy,MeadWestvaco,United States Steel,ArvinMeritor,WellChoice,OM Group,Asbury Automotive Group,Pepco Holdings,L-3 Communications,Washington Group Intl.,Triad Hospitals,Ross Stores,Auto-Owners Insurance,Erie Insurance Group,H&R Block,Starbucks,Advance Auto Parts,Universal Health Svcs.,PepsiAmericas,Guidant,Fisher Scientific Intl.,Roadway,Shaw Group,NVR,Affiliated Computer Svcs.,Stryker,Telephone & Data Sys.,Neiman Marcus,Medco Health Solutions,Travelers Property Casualty,Kinder Morgan Energy,Laidlaw International,WPS Resources,Apache,International Steel Group,CarMax,Western & Southern Financial,Bed Bath & Beyond,NTL,W.R. Berkley,Omnicare,Boston Scientific,Ryland Group,LandAmerica Financial,Henry Schein,Old Republic Intl.,Brinker International,MCI,News Corp.,TRW Automotive Holdings,DIRECTV Group,Liberty Media,Assurant,World Fuel Services,Enbridge Energy Partners,Hovnanian Enterprises,MDC Holdings,Beazer Homes USA,Toll Brothers,Whole Foods Market,UGI,Stater Bros. Holdings,Peabody Energy,Wendy's International,Cincinnati Financial,Chevron,Sears Holdings,Sprint Nextel,Lehman Brothers,Huntsman,\"Toys R\" Us,Genworth Financial,YRC Worldwide,TEPPCO Partners,PNC Financial Services Group,IAC/InterActiveCorp,Energy Transfer Partners,Google,Blockbuster,Freescale Semiconductor,Ryerson,BlueLinx Holdings,Liberty Global,Yahoo,Atmos Energy,Hershey,Chesapeake Energy,National Oilwell Varco,eBay,Hexion Specialty Chemicals,Tenneco,Mosaic,Franklin Resources,Freeport-McMoRan Cpr. & Gld,Constellation Brands,Fiserv,Standard Pacific,SunGard Data Systems,Frontier Oil,Marshall & Ilsley Corp.,URS,Expeditors Intl. of Washington,Pantry,Consol Energy,Community Health Sys.,PetSmart,M&T Bank Corp.,Michaels Stores,Health Management Associates,EOG Resources,Outback Steakhouse,Giant Industries,Sovereign Bancorp,Williams-Sonoma,CA,XTO Energy,Warner Music Group,North Fork Bancorp.,MDU Resources Group,Popular,Pactiv,Alliant Energy,Rockwell Collins,Tower Automotive,Manor Care,Synovus Financial Corp.,Dollar Tree Stores,Reliance Steel & Alum.,Nicor,Robert Half Intl.,Laboratory Corp. of America,Nalco Holding,Polo Ralph Lauren,Zimmer Holdings,Insight Enterprises,BJ Services,First Horizon National Corp.,FMC Technologies,JohnsonDiversey,Burlington Coat Factory,Swift Transportation,Simon Property Group,Bell Microproducts,Jarden,Forest Laboratories,FM Global,CH2M Hill,New Jersey Resources,TECO Energy,Electronic Arts,J.B. Hunt Transport Svcs.,Torchmark,Chemtura,Rockwood Holdings,EGL,GameStop,General Growth Properties,DaVita,Cintas,Country Insurance & Financial Services,Unitrin,American National Ins.,Crosstex Energy,UTStarcom,Meritage Homes,Cytec Industries,Mercury General,Energizer Holdings,Lithia Motors,Alaska Air Group,Hanover Insurance Group,Ruddick,MasterCard,St. Jude Medical,Building Materials Holding,CB Richard Ellis Group,Leucadia National,Hewitt Associates,Unified Western Grocers,Republic Services,Retail Ventures,Solutia,Abercrombie & Fitch,Charming Shoppes,Genzyme,CUNA Mutual Group,Questar,NRG Energy,AGL Resources,Belk,Broadcom,Payless Shoesource,Linens 'n Things,Granite Construction,Hospira,Dick's Sporting Goods,ABM Industries,A.G. Edwards,Great Plains Energy,WCI Communities,Peoples Energy,Symantec,Convergys,W.R. Grace,CBRL Group,Thor Industries,ETrade Financial,Vornado Realty Trust,Sabre Holdings,US Oncology,Cooper Cameron,Landstar System,Regal Entertainment Group,DST Systems,Sports Authority,Arch Coal,Jack in the Box,UAP Holding,Legg Mason,Casey's General Stores,CenturyTel,IDT,New Century Financial,Solo Cup,Stewart Information Services,Aleris International,Greif,Biogen Idec,Patterson,Pioneer Natural Resources,Airgas,Hayes Lemmerz,Graphic Packaging,Zale,International Game Technology,Nvidia,Scotts Miracle-Gro,Corn Products Intl.,Spectrum Brands,Manitowoc,Zions Bancorp,Tiffany,Dura Automotive Systems,Rent A Center,Builders FirstSource,StanCorp Financial,Amerigroup,Sentry Insurance Group,American Eagle Outfitters,SanDisk,Gold Kist,MBIA,Huntington Bancshares,Ingles Markets,Vanguard Health Systems,Minnesota Life Ins.,Benchmark Electronics,Apollo Group,Brightpoint,Pep Boys,Boyd Gaming,Weis Markets,Hawaiian Electric Inds.,Compass Bancshares,Markel,Regis,Noble Energy,WGL Holdings,Steel Dynamics,J.M. Smucker,Volt Info. Sciences,Acuity Brands,Citizens Communications,Raymond James Financial,UICI,Protective Life,Commerce Bancorp,Albemarle,Amkor Technology,Intuit,KLA-Tencor,Quintiles Transnational,Scholastic,Iron Mountain,Systemax,PNM Resources,AnnTaylor Stores,Tractor Supply,Juniper Networks,United Natural Foods,Equity Residential,National Fuel Gas,O'Reilly Automotive,Pride International,Career Education,Gilead Sciences,Vectren,Southern Union,Martin Marietta Materials,Amerco,Spansion,Perot Systems,Petco Animal Supplies,Movie Gallery,American Power Conversion,Werner Enterprises,Adobe Systems,SkyWest,Andrew,Univision Communications,Terra Industries,Select Medical,Chiron,LifePoint Hospitals,Pier 1 Imports,Commerce Group,Jo Ann Stores,ProLogis,Biomet,WellCare Health Plans,Polaris Industries,Maverick Tube,Rush Enterprises,Medical Mutual of Ohio,Arkansas Best,Pacer International,Quanta Services,William Lyon Homes,Ferrellgas Partners,Sunrise Senior Living,Magellan Health Svcs.,Amphenol,AMC Entertainment,Nextel Partners,Cabela's,Superior Essex,Guitar Center,Quiksilver,King Pharmaceuticals,Symbol Technologies,Indymac Bancorp,Newfield Exploration,Piedmont Natural Gas,IMS Health,Cenveo,Marsh Supermarkets,NII Holdings,Las Vegas Sands,NBTY,Church & Dwight,JLG Industries,Rock-Tenn,Perini,Moody's,Men's Wearhouse,Applied Ind. Technologies,Flowers Foods,Dentsply International,Southwest Gas,Mutual of America Life,Coach,Ohio Casualty,Metal Management,Jetblue Airways,Selective Insurance Group,Genesis HealthCare,MPS Group,Watsco,Agere Systems,Atmel,Ralcorp Holdings,Maxim Integrated Products,Children's Place,Alexander & Baldwin,Ambac Financial Group,VeriSign,Amica Mutual Insurance,Dex Media,Dade Behring Holdings,Molina Healthcare,Watson Pharmaceuticals,HCC Insurance Holdings,Armor Holdings,Alpha Natural Resources,CACI,Agilysys,AIMCO,Suburban Propane Partners,AmerUs Group,Vertis,Earle M. Jorgensen,Network Appliance,Laclede Group,Donaldson,CSK Auto,Blyth,Duane Reade,Westar Energy,Plum Creek Timber,Xilinx,Renal Care Group,Timberland,ExpressJet Holdings,USEC,SCP Pool,Alliance Data Systems,Sauer-Danfoss,Modine Manufacturing,Fred's,Knights of Columbus,Thornburg Mortgage,CKE Restaurants,Oil States International,Hub Group,Invacare,MGIC Investment,West,Iasis Healthcare,Fastenal,Autodesk,Dollar Thrifty Automotive,Belo,T. Rowe Price,Domino's Pizza,Centene,Lam Research,Federated Mutual Ins.,Jefferies Group,Arthur J. Gallagher,Anteon International,Penn National Gaming,Mettler-Toledo International,Stein Mart,Pogo Producing,Apria Healthcare Group,PSS World Medical,ScanSource,ABX Air,BMC Software,Bob Evans Farms,Ceridian,Roper Industries,AmeriCredit,Airtran Holdings,Boston Properties,Paychex,PC Connection,Dun & Bradstreet,Equifax,Schulman (A.),XO Communications,Siebel Systems,Regal-Beloit,Lehman Brothers Holdings,CVS/Caremark,Hess,Travelers Cos.,Massachusetts Mutual Life Insurance,Apple,Enterprise GP Holdings,Unum Group,S&C Holdco 3,Ameriprise Financial,SAIC,Hertz Global Holdings,Energy Transfer Equity,Integrys Energy Group,Virgin Media,Est&iuml,Realogy,Synnex,Boise Cascade Holdings,Avis Budget Group,Host Hotels & Resorts,Nash-Finch,Global Partners,Western Union,Con-way,Western Refining,Core-Mark Holding,Sirva,OSI Restaurant Partners,United Rentals,E*Trade Financial,Wyndham Worldwide,Thermo Fisher Scientific,Cameron International,Live Nation,Armstrong World Industries,Bon-Ton Stores,VWR International,Flowserve,Linens Holding,US Oncology Holdings,Patterson -UTI Energy,Westlake Chemical,NYSE Euronext,National Life Group,Expedia,American Home Mortgage Holdings,Alliance One International,Cooper-Standard Holdings,Affinia Group Intermediate Holdings,NewPage Holding,TD Ameritrade,HealthMarkets,McClatchy,BlackRock,Susser Holdings,Burger King Holdings,Jones Lang LaSalle,LSI,DynCorp,ACCO Brands,Pool,Donnelly,Nelnet,Select Medical Holdings,Schnitzer Steel Industries,Source Interlink Cos.,Grant Prideco,Petro Stopping Centers,ENSCO International,Metals USA,Goodman Global,Cephalon,Tupperware Brands,DRS Technologies,Sierra Health Services,Hanover Compressor,Gardner Denver,Kansas City So. Industries,Novellus Systems,Nasdaq Stock Market,Fairchild Semicond. Intl.,Chico's FAS,Colonial Bancgroup,Calumet Specialty Products,Griffon,Commscope,Central Garden & Pet,Hudson City Bancorp,AptarGroup,Varian Medical Systems,Aventine Renewable Energy Holdings,Viewsonic,Imation,Palm,Associated Banc,NCI Building Systems,American International Group,International Business Machines,CVS Caremark,State Farm Insurance Cos.,Kraft Foods,Honeywell International,GMAC,Macy's,Liberty Mutual Insurance Group,Plains All American Pipeline,Freeport-McMoRan Copper & Gold,Burlington Northern Santa Fe,Bank of New York Mellon Corp.,United Services Automobile Assn.,Toys 'R' Us,Penske Automotive Group,State Street Corp.,Knight,DISH Network,Air Products & Chemicals,Guardian Life Ins. Co. of America,Automatic Data Processing,Dana Holding,KBR,Jacobs Engineering Group,Energy Future Holdings,Community Health Systems,Targa Resources,Reliance Steel & Aluminum,American Family Insurance Group,Embarq,Oshkosh,TravelCenters of America,Starwood Hotels & Resorts,Affiliated Computer Services,Expeditors International of Washington,Telephone & Data Systems,Western & Southern Financial Group,Fidelity National Information Services,Universal Health Services,Spectra Energy,Chiquita Brands International,Robert Half International,Hanesbrands,International Assets Holding,American Financial Group,Mutual of Omaha Insurance,Dollar Tree,AECOM Technology,Old Republic International,AbitibiBowater,LandAmerica Financial Group,Zions Bancorp.,Harman International Industries,VWR Funding,J.B. Hunt Transport Services,BearingPoint,Corn Products International,Windstream,American Axle & Manufacturing,Idearc,Country Insurance & Fin. Svcs.,American National Insurance,Berry Plastics Group,Blackstone Group,Collective Brands,Icahn Enterprises,CVR Energy,PHH,Securian Financial Group,NetApp,CF Industries Holdings,Wynn Resorts,Mylan,Adams Resources & Energy,Barr Pharmaceuticals,Exterran Holdings,Hawaiian Electric Industries,Sally Beauty Holdings,Universal Forest Products,Graham Packaging,Nasdaq OMX Group,Annaly Capital Management,Andersons,Volt Information Sciences,Service Corp. International,International Flavors & Fragrances,MetroPCS Communications,Pep Boys-Manny, Moe & Jack,Children's Place Retail Stores,Magellan Health Services,Furniture Brands International,Cognizant Technology Solutions,Patterson-UTI Energy,Rowan,DynCorp International,Belden,Source Interlink,Hill-Rom Holdings,Interactive Brokers Group,Applied Industrial Technologies,CACI International,MEMC Electronic Materials,HealthExtras,Mueller Water Products,Metals USA Holdings,Brookdale Senior Living,Baldor Electric,Public Storage,Century Aluminum,RSC Holdings,Helix Energy Solutions Group,CME Group,Guess,Oceaneering International,Portland General Electric,Kansas City Southern,Chaparral Steel,MSC Industrial Direct,Duane Reade Holdings,Cinemark Holdings,New York Community Bancorp,BE Aerospace,Fairchild Semiconductor Intl.,Dresser-Rand Group,Key Energy Services,Complete Production Services,Beacon Roofing Supply,Covance,Leap Wireless International,Helmerich & Payne,Philip Morris International,United Services Automobile Association,Est?e Lauder,Discover Financial Services,CC Media Holdings,Domtar,Visa,Dr Pepper Snapple Group,NuStar Energy,Unified Grocers,Graphic Packaging Holding,Discovery Communications,Jones Financial,Cliffs Natural Resources,NV Energy,Berry Plastics,Country Ins. & Financial Services,VeraSun Energy,Activision Blizzard,Tiffany & Co,HSN,Buildings Materials Corp. of America,WABCO Holdings,Catalyst Health Solutions,Bucyrus International,Boise,Plains Exploration and Production,Intl. Flavors & Fragrances,Cracker Barrel Old Country Store,Applied Biosystems,NTK Holdings,Southwestern Energy,Celgene,Frontier Communications,Broadridge Financial Solutions,Rowan Cos.,HealthSpring,Atlas America,ON Semiconductor,Enersys,Cimarex Energy,PharMerica,Total System Services,LKQ,Itron,M&F Worldwide,Moog,Jo-Ann Stores,Buckeye GP Holdings,Teledyne Technologies,A?ropostale,Priceline.com,Superior Energy Services,Inergy Holdings,Kinetic Concepts,ManTech International,Lender Processing Services,RBS Global,Plexus,Urban Outfitters,Wendy's/Arby's Group,Perrigo,Radian Group,Michael Foods,Cypress Semiconductor,Vought Aircraft Industries,Psychiatric Solutions,KAR Holdings,Verso Paper,Bio-Rad Laboratories,Teradata,Watson Wyatt Worldwide,Eagle Rock Energy Partners,Sanderson Farms"
                .Split(',');

        private readonly string[] firstNames =
            "Jacob,Emma,Michael,Isabella,Ethan,Emily,Joshua,Madison,Daniel,Ava,Alexander,Olivia,Anthony,Sophia,William,Abigail,Christopher,Elizabeth,Matthew,Chloe,Jayden,Samantha,Andrew,Addison,Joseph,Natalie,David,Mia,Noah,Alexis,Aiden,Alyssa,James,Hannah,Ryan,Ashley,Logan,Ella,John,Sarah,Nathan,Grace,Elijah,Taylor,Christian,Brianna,Gabriel,Lily,Benjamin,Hailey,Jonathan,Anna,Tyler,Victoria,Samuel,Kayla,Nicholas,Lillian,Gavin,Lauren,Dylan,Kaylee,Jackson,Allison,Brandon,Savannah,Caleb,Nevaeh,Mason,Gabriella,Angel,Sofia,Isaac,Makayla,Evan,Avery,Jack,Riley,Kevin,Julia,Jose,Leah,Isaiah,Aubrey,Luke,Jasmine,Landon,Audrey,Justin,Katherine,Lucas,Morgan,Zachary,Brooklyn,Jordan,Destiny,Robert,Sydney,Aaron,Alexa,Brayden,Kylie,Thomas,Brooke,Cameron,Kaitlyn,Hunter,Evelyn,Austin,Layla,Adrian,Madeline,Connor,Kimberly,Owen,Zoe,Aidan,Jessica,Jason,Peyton,Julian,Alexandra,Wyatt,Claire,Charles,Madelyn,Luis,Maria,Carter,Mackenzie,Juan,Arianna,Chase,Jocelyn,Diego,Amelia,Jeremiah,Angelina,Brody,Trinity,Xavier,Andrea,Adam,Maya,Carlos,Valeria,Sebastian,Sophie,Liam,Rachel,Hayden,Vanessa,Nathaniel,Aaliyah,Henry,Mariah,Jesus,Gabrielle,Ian,Katelyn,Tristan,Ariana,Bryan,Bailey,Sean,Camila,Cole,Jennifer,Alex,Melanie,Eric,Gianna,Brian,Charlotte,Jaden,Paige,Carson,Autumn,Blake,Payton,Ayden,Faith,Cooper,Sara,Dominic,Isabelle,Brady,Caroline,Caden,Genesis,Josiah,Isabel,Kyle,Mary,Colton,Zoey,Kaden,Gracie,Eli,Megan,Miguel,Haley,Antonio,Mya,Parker,Michelle,Steven,Molly,Alejandro,Stephanie,Riley,Nicole,Richard,Jenna,Timothy,Natalia,Devin,Sadie,Jesse,Jada,Victor,Serenity,Jake,Lucy,Joel,Ruby,Colin,Eva,Kaleb,Kennedy,Bryce,Rylee,Levi,Jayla,Oliver,Naomi,Oscar,Rebecca,Vincent,Lydia,Ashton,Daniela,Cody,Bella,Micah,Keira,Preston,Adriana,Marcus,Lilly,Max,Hayden,Patrick,Miley,Seth,Katie,Jeremy,Jade,Peyton,Jordan,Nolan,Gabriela,Ivan,Amy,Damian,Angela,Maxwell,Melissa,Alan,Valerie,Kenneth,Giselle,Jonah,Diana,Jorge,Amanda,Mark,Kate,Giovanni,Laila,Eduardo,Reagan,Grant,Jordyn,Collin,Kylee,Gage,Danielle,Omar,Briana,Emmanuel,Marley,Trevor,Leslie,Edward,Kendall,Ricardo,Catherine,Cristian,Liliana,Nicolas,Mckenzie,Kayden,Jacqueline,George,Ashlyn,Jaxon,Reese,Paul,Marissa,Braden,London,Elias,Juliana,Andres,Shelby,Derek,Cheyenne,Garrett,Angel,Tanner,Daisy,Malachi,Makenzie,Conner,Miranda,Fernando,Erin,Cesar,Amber,Javier,Alana,Miles,Ellie,Jaiden,Breanna,Alexis,Ana,Leonardo,Mikayla,Santiago,Summer,Francisco,Piper,Cayden,Adrianna,Shane,Jillian,Edwin,Sierra,Hudson,Jayden,Travis,Sienna,Bryson,Alicia,Erick,Lila,Jace,Margaret,Hector,Alivia,Josue,Brooklynn,Peter,Karen,Jaylen,Violet,Mario,Sabrina,Manuel,Stella,Abraham,Aniyah,Grayson,Annabelle,Damien,Alexandria,Kaiden,Kathryn,Spencer,Skylar,Stephen,Aliyah,Edgar,Delilah,Wesley,Julianna,Shawn,Kelsey,Trenton,Khloe,Jared,Carly,Jeffrey,Amaya,Landen,Mariana,Johnathan,Christina,Bradley,Alondra,Braxton,Tessa,Ryder,Eliana,Camden,Bianca,Roman,Jazmin,Asher,Clara,Brendan,Vivian,Maddox,Josephine,Sergio,Delaney,Israel,Scarlett,Andy,Elena,Lincoln,Cadence,Erik,Alexia,Donovan,Maggie,Raymond,Laura,Avery,Nora,Rylan,Ariel,Dalton,Elise,Harrison,Nadia,Andre,Mckenna,Martin,Chelsea,Keegan,Lyla,Marco,Alaina,Jude,Jasmin,Sawyer,Hope,Dakota,Leila,Leo,Caitlyn,Calvin,Cassidy,Kai,Makenna,Drake,Allie,Troy,Izabella,Zion,Eden,Clayton,Callie,Roberto,Haylee,Zane,Caitlin,Gregory,Kendra,Tucker,Karina,Rafael,Kyra,Kingston,Kayleigh,Dominick,Addyson,Ezekiel,Kiara,Griffin,Jazmine,Devon,Karla,Drew,Camryn,Lukas,Alina,Johnny,Lola,Ty,Kyla,Pedro,Kelly,Tyson,Fatima,Caiden,Tiffany,Mateo,Kira,Braylon,Crystal,Cash,Mallory,Aden,Esmeralda,Chance,Alejandra,Taylor,Eleanor,Marcos,Angelica,Maximus,Jayda,Ruben,Abby,Emanuel,Kara,Simon,Veronica,Corbin,Carmen,Brennan,Jamie,Dillon,Ryleigh,Skyler,Valentina,Myles,Allyson,Xander,Dakota,Jaxson,Kamryn,Dawson,Courtney,Kameron,Cecilia,Kyler,Madeleine,Axel,Aniya,Colby,Alison,Jonas,Esther,Joaquin,Heaven,Payton,Aubree,Brock,Lindsey,Frank,Leilani,Enrique,Nina,Quinn,Melody,Emilio,Macy,Malik,Ashlynn,Grady,Joanna,Angelo,Cassandra,Julio,Alayna,Derrick,Kaydence,Raul,Madilyn,Fabian,Aurora,Corey,Heidi,Gerardo,Emerson,Dante,Kimora,Ezra,Madalyn,Armando,Erica,Allen,Josie,Theodore,Katelynn,Gael,Guadalupe,Amir,Harper,Zander,Ivy,Adan,Lexi,Maximilian,Camille,Randy,Savanna,Easton,Dulce,Dustin,Daniella,Luca,Lucia,Phillip,Emely,Julius,Joselyn,Charlie,Kiley,Ronald,Kailey,Jakob,Miriam,Cade,Cynthia,Brett,Rihanna,Trent,Georgia,Silas,Rylie,Keith,Harmony,Emiliano,Kiera,Trey,Kyleigh,Jalen,Monica,Darius,Bethany,Lane,Kaylie,Jerry,Cameron,Jaime,Teagan,Scott,Cora,Graham,Brynn,Weston,Ciara,Braydon,Genevieve,Anderson,Alice,Rodrigo,Maddison,Pablo,Eliza,Saul,Tatiana,Danny,Jaelyn,Donald,Erika,Elliot,Ximena,Brayan,April,Dallas,Marely,Lorenzo,Julie,Casey,Danica,Mitchell,Presley,Alberto,Brielle,Tristen,Julissa,Rowan,Angie,Jayson,Iris,Gustavo,Brenda,Aaden,Hazel,Amari,Rose,Dean,Malia,Braeden,Shayla,Declan,Fiona,Chris,Phoebe,Ismael,Nayeli,Dane,Paola,Louis,Kaelyn,Arturo,Selena,Brenden,Audrina,Felix,Rebekah,Jimmy,Carolina,Cohen,Janiyah,Tony,Michaela,Holden,Penelope,Reid,Janiya,Abel,Anastasia,Bennett,Adeline,Zackary,Ruth,Arthur,Sasha,Nehemiah,Denise,Ricky,Holly,Esteban,Madisyn,Cruz,Hanna,Finn,Tatum,Mauricio,Marlee,Dennis,Nataly,Keaton,Helen,Albert,Janelle,Marvin,Lizbeth,Mathew,Serena,Larry,Anya,Moises,Jaslene,Issac,Kaylin,Philip,Jazlyn,Quentin,Nancy,Curtis,Lindsay,Greyson,Desiree,Jameson,Hayley,Everett,Itzel,Jayce,Imani,Darren,Madelynn,Elliott,Asia,Uriel,Kadence,Alfredo,Madyson,Hugo,Talia,Alec,Jane,Jamari,Kayden,Marshall,Annie,Walter,Amari,Judah,Bridget,Jay,Raegan,Lance,Jadyn,Beau,Celeste,Ali,Jimena,Landyn,Luna,Yahir,Yasmin,Phoenix,Emilia,Nickolas,Annika,Kobe,Estrella,Bryant,Sarai,Maurice,Lacey,Russell,Ayla,Leland,Alessandra,Colten,Willow,Reed,Nyla,Davis,Dayana,Joe,Lilah,Ernesto,Lilliana,Desmond,Natasha,Kade,Hadley,Reece,Harley,Morgan,Priscilla,Ramon,Claudia,Rocco,Allisson,Orlando,Baylee,Ryker,Brenna,Brodie,Brittany,Paxton,Skyler,Jacoby,Fernanda,Douglas,Danna,Kristopher,Melany,Gary,Cali,Lawrence,Lia,Izaiah,Macie,Solomon,Lyric,Nikolas,Logan,Mekhi,Gloria,Justice,Lana,Tate,Mylee,Jaydon,Cindy,Salvador,Lilian,Shaun,Amira,Alvin,Anahi,Eddie,Alissa,Kane,Anaya,Davion,Lena,Zachariah,Ainsley,Dorian,Sandra,Titus,Noelle,Kellen,Marisol,Camron,Meredith,Isiah,Kailyn,Javon,Lesly,Nasir,Johanna,Milo,Diamond,Johan,Evangeline,Byron,Juliet,Jasper,Kathleen,Jonathon,Meghan,Chad,Paisley,Marc,Athena,Kelvin,Hailee,Chandler,Rosa,Sam,Wendy,Cory,Emilee,Deandre,Sage,River,Alanna,Reese,Elaina,Roger,Cara,Quinton,Nia,Talon,Paris,Romeo,Casey,Franklin,Dana,Noel,Emery,Alijah,Rowan,Guillermo,Aubrie,Gunner,Kaitlin,Damon,Jaden,Jadon,Kenzie,Emerson,Kiana,Micheal,Viviana,Bruce,Norah,Terry,Lauryn,Kolton,Perla,Melvin,Amiyah,Beckett,Alyson,Porter,Rachael,August,Shannon,Brycen,Aileen,Dayton,Miracle,Jamarion,Lillie,Leonel,Danika,Karson,Heather,Zayden,Kassidy,Keagan,Taryn,Carl,Tori,Khalil,Francesca,Cristopher,Kristen,Nelson,Amya,Braiden,Elle,Moses,Kristina,Isaias,Cheyanne,Roy,Haylie,Triston,Patricia,Walker,Anne,Kale,Samara,Jermaine,Skye,Leon,Kali,Rodney,America,Kristian,Lexie,Mohamed,Parker,Ronan,Halle,Pierce,Londyn,Trace,Abbigail,Warren,Linda,Jeffery,Hallie,Maverick,Saniya,Cyrus,Bryanna,Quincy,Bailee,Nathanael,Jaylynn,Skylar,Mckayla,Tommy,Quinn,Conor,Jaelynn,Noe,Jaida,Ezequiel,Caylee,Demetrius,Jaiden,Jaylin,Melina,Kendrick,Abril,Frederick,Sidney,Terrance,Kassandra,Bobby,Elisabeth,Jamison,Adalyn,Jon,Kaylynn,Rohan,Mercedes,Jett,Yesenia,Kieran,Elliana,Tobias,Brylee,Ari,Dylan,Colt,Isabela,Gideon,Ryan,Felipe,Ashlee,Kenny,Daphne,Wilson,Kenya,Orion,Marina,Kamari,Christine,Gunnar,Mikaela,Jessie,Kaitlynn,Alonzo,Justice,Gianni,Saniyah,Omari,Jaliyah,Waylon,Ingrid,Malcolm,Marie,Emmett,Natalee,Abram,Joy,Julien,Juliette,London,Simone,Tomas,Adelaide,Allan,Krystal,Terrell,Kennedi,Matteo,Mila,Tristin,Tamia,Jairo,Addisyn,Reginald,Aylin,Brent,Dayanara,Ahmad,Sylvia,Yandel,Clarissa,Rene,Maritza,Willie,Virginia,Boston,Braelyn,Billy,Jolie,Marlon,Jaidyn,Trevon,Kinsley,Aydan,Kirsten,Jamal,Laney,Aldo,Marilyn,Ariel,Whitney,Cason,Janessa,Braylen,Raquel,Javion,Anika,Joey,Kamila,Rogelio,Aria,Ahmed,Rubi,Dominik,Adelyn,Brendon,Amara,Toby,Ayanna,Kody,Teresa,Marquis,Zariah,Ulises,Kaleigh,Armani,Amani,Adriel,Carla,Alfonso,Yareli,Branden,Gwendolyn,Will,Paulina,Craig,Nathalie,Ibrahim,Annabella,Osvaldo,Jaylin,Wade,Tabitha,Harley,Deanna,Steve,Madalynn,Davin,Journey,Deshawn,Aiyana,Kason,Skyla,Damion,Yaretzi,Jaylon,Ada,Jefferson,Liana,Aron,Karlee,Brooks,Jenny,Darian,Myla,Gerald,Cristina,Rolando,Myah,Terrence,Lisa,Enzo,Tania,Kian,Isis,Ryland,Jayleen,Barrett,Jordin,Jaeden,Arely,Ben,Azul,Bradyn,Helena,Giovani,Aryanna,Blaine,Jaqueline,Madden,Lucille,Jerome,Destinee,Muhammad,Martha,Ronnie,Zoie,Layne,Arielle,Kolby,Liberty,Leonard,Marlene,Vicente,Elisa,Cale,Isla,Alessandro,Noemi,Zachery,Raven,Gavyn,Jessie,Aydin,Aleah,Xzavier,Kailee,Malakai,Kaliyah,Raphael,Lilyana,Cannon,Haven,Rudy,Tara,Asa,Giana,Darrell,Camilla,Giancarlo,Maliyah,Elisha,Irene,Junior,Carley,Zackery,Maeve,Alvaro,Lea,Lewis,Macey,Valentin,Sharon,Deacon,Alisha,Jase,Marisa,Harry,Jaylene,Kendall,Kaya,Rashad,Scarlet,Finnegan,Siena,Mohammed,Adyson,Ramiro,Maia,Cedric,Shiloh,Brennen,Tiana,Santino,Jaycee,Stanley,Gisselle,Tyrone,Yazmin,Chace,Eve,Francis,Shyanne,Johnathon,Arabella,Teagan,Sherlyn,Zechariah,Sariah,Alonso,Amiya,Kaeden,Kiersten,Kamden,Madilynn,Gilberto,Shania,Ray,Aleena,Karter,Finley,Luciano,Kinley,Nico,Kaia,Kole,Aliya,Aryan,Taliyah,Draven,Pamela,Jamie,Yoselin,Misael,Ellen,Lee,Carlie,Alexzander,Monserrat,Camren,Jakayla,Giovanny,Reyna,Amare,Yaritza,Rhett,Carolyn,Rhys,Clare,Rodolfo,Lorelei,Nash,Paula,Markus,Zaria,Deven,Gracelyn,Mohammad,Kasey,Moshe,Regan,Quintin,Alena,Dwayne,Angelique,Memphis,Regina,Atticus,Britney,Davian,Emilie,Eugene,Mariam,Jax,Jaylee,Antoine,Julianne,Wayne,Greta,Randall,Elyse,Semaj,Lainey,Uriah,Kallie,Clark,Felicity,Aidyn,Zion,Jorden,Aspen,Maxim,Carlee,Aditya,Annalise,Lawson,Iliana,Messiah,Larissa,Korbin,Akira,Sullivan,Sonia,Freddy,Catalina,Demarcus,Phoenix,Neil,Joslyn,Brice,Anabelle,King,Mollie,Davon,Susan,Elvis,Judith,Ace,Destiney,Dexter,Hillary,Heath,Janet,Duncan,Katrina,Jamar,Mareli,Sincere,Ansley,Irvin,Kaylyn,Remington,Alexus,Kadin,Gia,Soren,Maci,Tyree,Elsa,Damarion,Stacy,Talan,Kaylen,Adrien,Carissa,Gilbert,Haleigh,Keenan,Lorena,Darnell,Jazlynn,Adolfo,Milagros,Tristian,Luz,Derick,Leanna,Isai,Renee,Rylee,Shaniya,Gauge,Charlie,Harold,Abbie,Kareem,Cailyn,Deangelo,Cherish,Agustin,Elsie,Coleman,Jazmyn,Zavier,Elaine,Lamar,Emmalee,Emery,Luciana,Jaydin,Dahlia,Devan,Jamya,Jordyn,Belinda,Mathias,Mariyah,Prince,Chaya,Sage,Dayami,Seamus,Rhianna,Jasiah,Yadira,Efrain,Aryana,Darryl,Rosemary,Arjun,Armani,Mike,Cecelia,Roland,Celia,Conrad,Barbara,Kamron,Cristal,Hamza,Eileen,Santos,Rayna,Frankie,Campbell,Dominique,Amina,Marley,Aisha,Vance,Amirah,Dax,Ally,Jamir,Araceli,Kylan,Averie,Todd,Mayra,Maximo,Sanaa,Jabari,Patience,Matthias,Leyla,Haiden,Selah,Luka,Zara,Marcelo,Chanel,Keon,Kaiya,Layton,Keyla,Tyrell,Miah,Kash,Aimee,Raiden,Giovanna,Cullen,Amelie,Donte,Kelsie,Jovani,Alisson,Cordell,Angeline,Kasen,Dominique,Rory,Adrienne,Alfred,Brisa,Darwin,Cierra,Ernest,Paloma,Bailey,Isabell,Gaige,Precious,Hassan,Alma,Jamarcus,Charity,Killian,Jacquelyn,Augustus,Janae,Trevin,Frances,Zain,Shyla,Ellis,Janiah,Rex,Kierra,Yusuf,Karlie,Bruno,Annabel,Jaidyn,Jacey,Justus,Karissa,Ronin,Jaylah,Humberto,Xiomara,Jaquan,Edith,Josh,Marianna,Kasey,Damaris,Winston,Deborah,Dashawn,Jaylyn,Lucian,Evelin,Matias,Mara,Sidney,Olive,Ignacio,Ayana,Nigel,India,Van,Kendal,Elian,Kayley,Finley,Tamara,Jaron,Briley,Addison,Charlee,Aedan,Nylah,Braedon,Abbey,Jadyn,Moriah,Konner,Saige,Zayne,Savanah,Franco,Giada,Niko,Hana,Savion,Lizeth,Cristofer,Matilda,Deon,Ann,Krish,Jazlene,Anton,Gillian,Brogan,Beatrice,Cael,Ireland,Coby,Karly,Kymani,Mylie,Marcel,Yasmine,Yair,Ashly,Dale,Kenna,Bo,Maleah,Jordon,Corinne,Samir,Keely,Darien,Tanya,Zaire,Tianna,Ross,Adalynn,Vaughn,Ryann,Devyn,Salma,Kenyon,Areli,Clay,Karma,Dario,Shyann,Ishaan,Kaley,Jair,Theresa,Kael,Evie,Adonis,Gina,Jovanny,Roselyn,Clinton,Kaila,Rey,Jaylen,Chaim,Natalya,German,Meadow,Harper,Rayne,Nathen,Aliza,Rigoberto,Yuliana,Sonny,June,Glenn,Lilianna,Octavio,Nathaly,Blaze,Ali,Keshawn,Alisa,Ralph,Aracely,Ean,Belen,Nikhil,Tess,Rayan,Jocelynn,Sterling,Litzy,Branson,Makena,Jadiel,Abagail,Dillan,Giuliana,Jeramiah,Joyce,Koen,Libby,Konnor,Lillianna,Antwan,Thalia,Houston,Tia,Tyrese,Sarahi,Dereon,Zaniyah,Leonidas,Kristin,Zack,Lorelai,Fisher,Mattie,Jaydan,Taniya,Quinten,Jaslyn,Nick,Gemma,Urijah,Valery,Darion,Lailah,Jovan,Mckinley,Salvatore,Micah,Beckham,Deja,Jarrett,Frida,Antony,Brynlee,Eden,Jewel,Makai,Krista,Zaiden,Mira,Broderick,Yamilet,Camryn,Adison,Malaki,Carina,Nikolai,Karli,Howard,Magdalena,Immanuel,Stephany,Demarion,Charlize,Valentino,Raelynn,Jovanni,Aliana,Ayaan,Cassie,Ethen,Mina,Leandro,Karley,Royce,Shirley,Yael,Marlie,Yosef,Alani,Jean,Taniyah,Marquise,Cloe,Alden,Sanai,Leroy,Lina,Gaven,Nola,Jovany,Anabella,Tyshawn,Dalia,Aarav,Raina,Kadyn,Mariela,Milton,Ariella,Zaid,Bria,Kelton,Kamari,Tripp,Monique,Kamren,Ashleigh,Slade,Reina,Hezekiah,Alia,Jakobe,Ashanti,Nathanial,Lara,Rishi,Lilia,Shamar,Justine,Geovanni,Leia,Pranav,Maribel,Roderick,Abigayle,Bentley,Tiara,Clarence,Alannah,Lyric,Princess,Bernard,Sydnee,Carmelo,Kamora,Denzel,Paityn,Maximillian,Payten,Reynaldo,Naima,Cassius,Gretchen,Gordon,Heidy,Reuben,Nyasia,Samson,Livia,Yadiel,Marin,Jayvon,Shaylee,Reilly,Maryjane,Sheldon,Laci,Abdullah,Nathalia,Jagger,Azaria,Thaddeus,Anabel,Case,Chasity,Kyson,Emmy,Lamont,Izabelle,Chaz,Denisse,Makhi,Emelia,Jan,Mireya,Marques,Shea,Oswaldo,Amiah,Donavan,Dixie,Keyon,Maren,Kyan,Averi,Simeon,Esperanza,Trystan,Micaela,Andreas,Selina,Dangelo,Alyvia,Landin,Chana,Reagan,Avah,Turner,Donna,Arnav,Kaylah,Brenton,Ashtyn,Callum,Karsyn,Jayvion,Makaila,Bridger,Shayna,Sammy,Essence,Deegan,Leticia,Jaylan,Miya,Lennon,Rory,Odin,Desirae,Abdiel,Kianna,Jerimiah,Laurel,Eliezer,Neveah,Bronson,Amaris,Cornelius,Hadassah,Pierre,Dania,Cortez,Hailie,Baron,Jamiya,Carlo,Kathy,Carsen,Laylah,Fletcher,Riya,Izayah,Diya,Kolten,Carleigh,Damari,Iyana,Hugh,Kenley,Jensen,Sloane,Yurem,Elianna"
                .Split(',');

        private readonly string[] lastNames =
            "Smith,Johnson,Williams,Jones,Brown,Davis,Miller,Wilson,Moore,Taylor,Anderson,Thomas,Jackson,White,Harris,Martin,Thompson,Garcia,Martinez,Robinson,Clark,Rodriguez,Lewis,Lee,Walker,Hall,Allen,Young,Hernandez,King,Wright,Lopez,Hill,Scott,Green,Adams,Baker,Gonzalez,Nelson,Carter,Mitchell,Perez,Roberts,Turner,Phillips,Campbell,Parker,Evans,Edwards,Collins,Stewart,Sanchez,Morris,Rogers,Reed,Cook,Morgan,Bell,Murphy,Bailey,Rivera,Cooper,Richardson,Cox,Howard,Ward,Torres,Peterson,Gray,Ramirez,James,Watson,Brooks,Kelly,Sanders,Price,Bennett,Wood,Barnes,Ross,Henderson,Coleman,Jenkins,Perry,Powell,Long,Patterson,Hughes,Flores,Washington,Butler,Simmons,Foster,Gonzales,Bryant,Alexander,Russell,Griffin,Diaz,Hayes,Myers,Ford,Hamilton,Graham,Sullivan,Wallace,Woods,Cole,West,Jordan,Owens,Reynolds,Fisher,Ellis,Harrison,Gibson,Mcdonald,Cruz,Marshall,Ortiz,Gomez,Murray,Freeman,Wells,Webb,Simpson,Stevens,Tucker,Porter,Hunter,Hicks,Crawford,Henry,Boyd,Mason,Morales,Kennedy,Warren,Dixon,Ramos,Reyes,Burns,Gordon,Shaw,Holmes,Rice,Robertson,Hunt,Black,Daniels,Palmer,Mills,Nichols,Grant,Knight,Ferguson,Rose,Stone,Hawkins,Dunn,Perkins,Hudson,Spencer,Gardner,Stephens,Payne,Pierce,Berry,Matthews,Arnold,Wagner,Willis,Ray,Watkins,Olson,Carroll,Duncan,Snyder,Hart,Cunningham,Bradley,Lane,Andrews,Ruiz,Harper,Fox,Riley,Armstrong,Carpenter,Weaver,Greene,Lawrence,Elliott,Chavez,Sims,Austin,Peters,Kelley,Franklin,Lawson,Fields,Gutierrez,Ryan,Schmidt,Carr,Vasquez,Castillo,Wheeler,Chapman,Oliver,Montgomery,Richards,Williamson,Johnston,Banks,Meyer,Bishop,Mccoy,Howell,Alvarez,Morrison,Hansen,Fernandez,Garza,Harvey,Little,Burton,Stanley,Nguyen,George,Jacobs,Reid,Kim,Fuller,Lynch,Dean,Gilbert,Garrett,Romero,Welch,Larson,Frazier,Burke,Hanson,Day,Mendoza,Moreno,Bowman,Medina,Fowler,Brewer,Hoffman,Carlson,Silva,Pearson,Holland,Douglas,Fleming,Jensen,Vargas,Byrd,Davidson,Hopkins,May,Terry,Herrera,Wade,Soto,Walters,Curtis,Neal,Caldwell,Lowe,Jennings,Barnett,Graves,Jimenez,Horton,Shelton,Barrett,Obrien,Castro,Sutton,Gregory,Mckinney,Lucas,Miles,Craig,Rodriquez,Chambers,Holt,Lambert,Fletcher,Watts,Bates,Hale,Rhodes,Pena,Beck,Newman,Haynes,Mcdaniel,Mendez,Bush,Vaughn,Parks,Dawson,Santiago,Norris,Hardy,Love,Steele,Curry,Powers,Schultz,Barker,Guzman,Page,Munoz,Ball,Keller,Chandler,Weber,Leonard,Walsh,Lyons,Ramsey,Wolfe,Schneider,Mullins,Benson,Sharp,Bowen,Daniel,Barber,Cummings,Hines,Baldwin,Griffith,Valdez,Hubbard,Salazar,Reeves,Warner,Stevenson,Burgess,Santos,Tate,Cross,Garner,Mann,Mack,Moss,Thornton,Dennis,Mcgee,Farmer,Delgado,Aguilar,Vega,Glover,Manning,Cohen,Harmon,Rodgers,Robbins,Newton,Todd,Blair,Higgins,Ingram,Reese,Cannon,Strickland,Townsend,Potter,Goodwin,Walton,Rowe,Hampton,Ortega,Patton,Swanson,Joseph,Francis,Goodman,Maldonado,Yates,Becker,Erickson,Hodges,Rios,Conner,Adkins,Webster,Norman,Malone,Hammond,Flowers,Cobb,Moody,Quinn,Blake,Maxwell,Pope,Floyd,Osborne,Paul,Mccarthy,Guerrero,Lindsey,Estrada,Sandoval,Gibbs,Tyler,Gross,Fitzgerald,Stokes,Doyle,Sherman,Saunders,Wise,Colon,Gill,Alvarado,Greer,Padilla,Simon,Waters,Nunez,Ballard,Schwartz,Mcbride,Houston,Christensen,Klein,Pratt,Briggs,Parsons,Mclaughlin,Zimmerman,French,Buchanan,Moran,Copeland,Roy,Pittman,Brady,Mccormick,Holloway,Brock,Poole,Frank,Logan,Owen,Bass,Marsh,Drake,Wong,Jefferson,Park,Morton,Abbott,Sparks,Patrick,Norton,Huff,Clayton,Massey,Lloyd,Figueroa,Carson,Bowers,Roberson,Barton,Tran,Lamb,Harrington,Casey,Boone,Cortez,Clarke,Mathis,Singleton,Wilkins,Cain,Bryan,Underwood,Hogan,Mckenzie,Collier,Luna,Phelps,Mcguire,Allison,Bridges,Wilkerson,Nash,Summers,Atkins,Wilcox,Pitts,Conley,Marquez,Burnett,Richard,Cochran,Chase,Davenport,Hood,Gates,Clay,Ayala,Sawyer,Roman,Vazquez,Dickerson,Hodge,Acosta,Flynn,Espinoza,Nicholson,Monroe,Wolf,Morrow,Kirk,Randall,Anthony,Whitaker,Oconnor,Skinner,Ware,Molina,Kirby,Huffman,Bradford,Charles,Gilmore,Dominguez,Oneal,Bruce,Lang,Combs,Kramer,Heath,Hancock,Gallagher,Gaines,Shaffer,Short,Wiggins,Mathews,Mcclain,Fischer,Wall,Small,Melton,Hensley,Bond,Dyer,Cameron,Grimes,Contreras,Christian,Wyatt,Baxter,Snow,Mosley,Shepherd,Larsen,Hoover,Beasley,Glenn,Petersen,Whitehead,Meyers,Keith,Garrison,Vincent,Shields,Horn,Savage,Olsen,Schroeder,Hartman,Woodard,Mueller,Kemp,Deleon,Booth,Patel,Calhoun,Wiley,Eaton,Cline,Navarro,Harrell,Lester,Humphrey,Parrish,Duran,Hutchinson,Hess,Dorsey,Bullock,Robles,Beard,Dalton,Avila,Vance,Rich,Blackwell,York,Johns,Blankenship,Trevino,Salinas,Campos,Pruitt,Moses,Callahan,Golden,Montoya,Hardin,Guerra,Mcdowell,Carey,Stafford,Gallegos,Henson,Wilkinson,Booker,Merritt,Miranda,Atkinson,Orr,Decker,Hobbs,Preston,Tanner,Knox,Pacheco,Stephenson,Glass,Rojas,Serrano,Marks,Hickman,English,Sweeney,Strong,Prince,Mcclure,Conway,Walter,Roth,Maynard,Farrell,Lowery,Hurst,Nixon,Weiss,Trujillo,Ellison,Sloan,Juarez,Winters,Mclean,Randolph,Leon,Boyer,Villarreal,Mccall,Gentry,Carrillo,Kent,Ayers,Lara,Shannon,Sexton,Pace,Hull,Leblanc,Browning,Velasquez,Leach,Chang,House,Sellers,Herring,Noble,Foley,Bartlett,Mercado,Landry,Durham,Walls,Barr,Mckee,Bauer,Rivers,Everett,Bradshaw,Pugh,Velez,Rush,Estes,Dodson,Morse,Sheppard,Weeks,Camacho,Bean,Barron,Livingston,Middleton,Spears,Branch,Blevins,Chen,Kerr,Mcconnell,Hatfield,Harding,Ashley,Solis,Herman,Frost,Giles,Blackburn,William,Pennington,Woodward,Finley,Mcintosh,Koch,Best,Solomon,Mccullough,Dudley,Nolan,Blanchard,Rivas,Brennan,Mejia,Kane,Benton,Joyce,Buckley,Haley,Valentine,Maddox,Russo,Mcknight,Buck,Moon,Mcmillan,Crosby,Berg,Dotson,Mays,Roach,Church,Chan,Richmond,Meadows,Faulkner,Oneill,Knapp,Kline,Barry,Ochoa,Jacobson,Gay,Avery,Hendricks,Horne,Shepard,Hebert,Cherry,Cardenas,Mcintyre,Whitney,Waller,Holman,Donaldson,Cantu,Terrell,Morin,Gillespie,Fuentes,Tillman,Sanford,Bentley,Peck,Key,Salas,Rollins,Gamble,Dickson,Battle,Santana,Cabrera,Cervantes,Howe,Hinton,Hurley,Spence,Zamora,Yang,Mcneil,Suarez,Case,Petty,Gould,Mcfarland,Sampson,Carver,Bray,Rosario,Macdonald,Stout,Hester,Melendez,Dillon,Farley,Hopper,Galloway,Potts,Bernard,Joyner,Stein,Aguirre,Osborn,Mercer,Bender,Franco,Rowland,Sykes,Benjamin,Travis,Pickett,Crane,Sears,Mayo,Dunlap,Hayden,Wilder,Mckay,Coffey,Mccarty,Ewing,Cooley,Vaughan,Bonner,Cotton,Holder,Stark,Ferrell,Cantrell,Fulton,Lynn,Lott,Calderon,Rosa,Pollard,Hooper,Burch,Mullen,Fry,Riddle,Levy,David,Duke,Odonnell,Guy,Michael,Britt,Frederick,Daugherty,Berger,Dillard,Alston,Jarvis,Frye,Riggs,Chaney,Odom,Duffy,Fitzpatrick,Valenzuela,Merrill,Mayer,Alford,Mcpherson,Acevedo,Donovan,Barrera,Albert,Cote,Reilly,Compton,Raymond,Mooney,Mcgowan,Craft,Cleveland,Clemons,Wynn,Nielsen,Baird,Stanton,Snider,Rosales,Bright,Witt,Stuart,Hays,Holden,Rutledge,Kinney,Clements,Castaneda,Slater,Hahn,Emerson,Conrad,Burks,Delaney,Pate,Lancaster,Sweet,Justice,Tyson,Sharpe,Whitfield,Talley,Macias,Irwin,Burris,Ratliff,Mccray,Madden,Kaufman,Beach,Goff,Cash,Bolton,Mcfadden,Levine,Good,Byers,Kirkland,Kidd,Workman,Carney,Dale,Mcleod,Holcomb,England,Finch,Head,Burt,Hendrix,Sosa,Haney,Franks,Sargent,Nieves,Downs,Rasmussen,Bird,Hewitt,Lindsay,Le,Foreman,Valencia,Oneil,Delacruz,Vinson,Dejesus,Hyde,Forbes,Gilliam,Guthrie,Wooten,Huber,Barlow,Boyle,Mcmahon,Buckner,Rocha,Puckett,Langley,Knowles,Cooke,Velazquez,Whitley,Noel,Vang"
                .Split(',');

        private readonly Random random = new Random();

        private Dispatcher dispatcher;

        public DataGenerator(Dispatcher dispatcher)
        {
            this.dispatcher = dispatcher;
        }

        public int CountActivities { get; private set; }
        public int CountContacts { get; private set; }
        public int CountLeads { get; private set; }
        public bool IsComplete { get; set; }

        private CRMDataContext db
        {
            get
            {
                return ((App)App.Current).CRMDataContext;
            }
        }

        public void Clear()
        {
            IsComplete = false;
            try
            {

                db.Contacts.DeleteAllOnSubmit(db.GetTable<Contact>());
                db.SubmitChanges();
                InvokeClearComplete(EventArgs.Empty);
            }
            finally
            {
                IsComplete = true;
            }
        }

        public void DropStorage()
        {
            IsComplete = false;
            try
            {
                using (var store = IsolatedStorageFile.GetUserStoreForApplication())
                {
                    if (db.DatabaseExists())
                    {
                        db.DeleteDatabase();
                    }
                }
                InvokeClearComplete(EventArgs.Empty);
            }
            finally
            {
                IsComplete = true;
            }
        }

        public void Generate(int maxObjects)
        {
            bool changedAfterCommit = false;
            int i = 0;
            while (i < maxObjects)
            {
                changedAfterCommit = true;
                var firstName = GetRandomElement((IList<string>)firstNames);
                var lastName = GetRandomElement((IList<string>)lastNames);
                var company = GetRandomElement((IList<string>)companies);
                i++;
                var contact = new Contact
                                  {
                                      FirstName = firstName,
                                      LastName = lastName,
                                      Company = company,
                                      Address =
                                          string.Format("Street {0}, b. #{1}", random.Next(500), random.Next(1000)),
                                      Email =
                                          string.Format("{0}.{1}@{2}.com", firstName, lastName, company.Replace(" ", ""))
                                  };

                //Adding Contact to collection
                db.Contacts.InsertOnSubmit(contact);
                CountContacts++;
                if (CountContacts % 1000 == 0)
                {
                    InvokeCommiting(EventArgs.Empty);
                    db.SubmitChanges();
                    changedAfterCommit = false;
                }
                InvokeGeneratedContact(EventArgs.Empty);
            }
            if (changedAfterCommit)
            {
                InvokeCommiting(EventArgs.Empty);
                db.SubmitChanges();
            }
            InvokeGenerationComplete(EventArgs.Empty);
        }

        private T GetRandomElement<T>(IList<T> list) where T : class
        {
            if (list == null) throw new ArgumentNullException("list");

            return list.Count > 0 ? list[random.Next(list.Count)] : null;
        }

        private object GetRandomElement(IList list)
        {
            if (list == null) throw new ArgumentNullException("list");

            return list.Count > 0 ? list[random.Next(list.Count)] : null;
        }

        private void InvokeClearComplete(EventArgs e)
        {
            var clearCompleteHandler = ClearComplete;
            if (clearCompleteHandler != null) clearCompleteHandler(this, e);
        }

        private void InvokeCommiting(EventArgs e)
        {
            var commitingHandler = Committing;
            if (commitingHandler != null) commitingHandler(this, e);
        }

        private void InvokeGeneratedContact(EventArgs e)
        {
            var generatedContactHandler = GeneratedContact;
            if (generatedContactHandler != null) generatedContactHandler(this, e);
        }

        private void InvokeGenerationComplete(EventArgs e)
        {
            var generationCompleteHandler = GenerationComplete;
            if (generationCompleteHandler != null) generationCompleteHandler(this, e);
        }

        public event EventHandler ClearComplete;
        public event EventHandler GenerationComplete;
        public event EventHandler GeneratedContact;
        public event EventHandler Committing;
    }
}